
local timePerUpdate=0
local timeTot=0
local Range=5
local MySwitch=""
local FireAlarm="NO"
local MySprinklers={}
local NumSprinklers=0
local GROUPS = {
		{"Sniper", "Workman", "Guard", "RiotGuard", "ArmedGuard", "Doctor", "Paramedic", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Teacher", "Soldier", "Warden", "Chief", "Foreman", "Psychologist", "Accountant", "Lawyer", "AppealsLawyer", "ParoleLawyer", "ParoleOfficer", "AppealsMagistrate", "SpiritualLeader", "Avatar", "Actor", "Prisoner", "Visitor"},
		{"Sniper", "Workman", "Guard", "RiotGuard", "ArmedGuard", "Doctor", "Paramedic", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Teacher", "Soldier", "Warden", "Chief", "Foreman", "Psychologist", "Accountant", "Lawyer", "AppealsLawyer", "ParoleLawyer", "ParoleOfficer", "AppealsMagistrate"},
		{"Prisoner", "Avator", "Actor"},
		{"Sniper", "Guard", "RiotGuard", "ArmedGuard", "Soldier"},
		{"Paramedic", "Fireman", "Soldier", "RiotGuard"},
		{"Warden", "Chief", "Foreman", "Psychologist", "Accountant", "Lawyer", "AppealsLawyer", "ParoleLawyer", "ParoleOfficer", "AppealsMagistrate"},
		{"Visitor"}}

function Create()
	local timePerUpdate=2.5
	Object.SetProperty(this,"Range",5)
	Object.SetProperty(this,"FireAlarm","NO")
	Interface.AddComponent(this,"toggleRange", "Button", "tooltip_button_ShowHideRange",this.Range,"X")
	Interface.AddComponent(this,"toggleFireAlarm", "Button", "tooltip_button_alsofirealarm","tooltip_off","X")
end

function toggleRangeClicked()
	Range=Range+5
	Object.SetProperty(this,"Range",Range)
	this.SetInterfaceCaption("toggleRange", "tooltip_button_ShowHideRange",this.Range,"X")
	if this.FireAlarm=="YES" then
		FindMySprinklers()
	end
	if Range>=50 then
		Range=0
	end
end

function toggleFireAlarmClicked()
	if FireAlarm=="YES" then
		FireAlarm="NO"
		this.SetInterfaceCaption("toggleFireAlarm", "tooltip_button_alsofirealarm","tooltip_off","X")
	else
		FireAlarm="YES"
		this.SetInterfaceCaption("toggleFireAlarm", "tooltip_button_alsofirealarm","tooltip_on","X")
	end
	Object.SetProperty(this,"FireAlarm",FireAlarm)
	if this.FireAlarm=="YES" then
		FindMySprinklers()
		Interface.AddComponent(this,"toggleFindSprinklers", "Button", "tooltip_button_scansprinklers",NumSprinklers,"X")
	else
		if next(MySprinklers) then
			for thatSprinkler, distance in pairs (MySprinklers) do
				if thatSprinkler.SubType==1 then
					Object.SetProperty(thatSprinkler,"SubType",0)
				end
			end
			NumSprinklers=0
		end
		Interface.RemoveComponent(this,"toggleFindSprinklers", "Button", "tooltip_button_scansprinklers",NumSprinklers,"X")
	end
end

function toggleFindSprinklersClicked()
	FindMySprinklers()
end

function FindMySwitch()
	local Switches = this.GetNearbyObjects('PowerSwitch',1000)
	for thatSwitch, distance in pairs (Switches) do
		if thatSwitch.Id.i==this.TriggeredBy.i and thatSwitch.Id.u==this.TriggeredBy.u then
			Object.SetProperty("HomeUID", thatSwitch.HomeUID)
			MySwitch = thatSwitch
			break
		end
	end
end

function FindMyEvacType()
	this.EvacType=""
	this.EvacPosX=""
	this.EvacPosY=""
	local Panels = this.GetNearbyObjects('Pager',1000)
	for thatPanel, distance in pairs (Panels) do
		if thatPanel.HomeUID==this.HomeUID then
			Object.SetProperty("EvacType", thatPanel.EvacType)
			Object.SetProperty("EvacPosX",thatPanel.Pos.x)
			Object.SetProperty("EvacPosY",thatPanel.Pos.y+3)
		end
	end
end

function FindMySprinklers()
	MySprinklers={}
	NumSprinklers=0
	MySprinklers = this.GetNearbyObjects('Sprinkler',this.Range)
	if next(MySprinklers) then
		for thatSprinkler, distance in pairs (MySprinklers) do
			if thatSprinkler.SubType==0 then
				Object.SetProperty(thatSprinkler,"SubType",1)
			end
			NumSprinklers=NumSprinklers+1
		end
	end
	this.SetInterfaceCaption("toggleFindSprinklers", "tooltip_button_scansprinklers",NumSprinklers,"X")
end

function DoEvacuate()
	FindMySwitch() -- find the switch which triggered me last time. if another booths switch is turned on, it will use that new one instead.
	FindMyEvacType() -- find the panel which belongs to it so we know which type of people should respond and the location where they should be send.
	if this.EvacType~=nil then
		Object.Sound("EvacAlarm","SoundAlarm")
		local group = GROUPS[this.EvacType]
		for _, typ in pairs(group) do
			local people = this.GetNearbyObjects(typ, this.Range)
			for entity, _ in pairs(people) do
				if entity.Type=="Prisoner" then
					Object.SetProperty(this,"Tooltip", "Used by Utility Booth nr. "..this.HomeUID.."\n\nSending "..entity.Category.." "..entity.Type.." at "..string.sub(tostring(_),0,4).."m\nto the Evacuation Area")
					Object.ClearRouting(entity) --clearrouting doesn't seem to kill jobs, so have to do that manually
					entity.JobID=0 -- kill prisoners job
					entity.Station.i=0 -- clear the links to whatever he was working on
					entity.Station.u=0
					entity.StatusEffects.suppressed = 0 -- remove suppression so he can run fast
					entity.Needs.Evacuation = 100 -- give him some reasons to run
					entity.Needs.Safety = 100
				else
					Object.SetProperty(this,"Tooltip", "Used by Utility Booth nr. "..this.HomeUID.."\n\nEvacuating "..entity.Type.." at "..string.sub(tostring(_),0,4).."m")
					Object.ClearRouting(entity)
					Object.NavigateTo(entity, this.EvacPosX, this.EvacPosY)
				end
			end
		end
	else
		Object.SetProperty(this,"Tooltip", "tooltip_EvacuationAlarmSelective",this.HomeUID,"S")
	end
end

function DoFireEvac()
	FindMySwitch() -- find the switch which triggered me last time. if another booths switch is turned on, it will use that new one instead.
	FindMyEvacType() -- find the panel which belongs to it so we know which type of people should respond and the location where they should be send.
	if this.EvacType~=nil then
        Object.Sound("_Failure","TimerTickHours")
		local group = GROUPS[1]
		for _, typ in pairs(group) do
			local people = this.GetNearbyObjects(typ, this.Range)
			for entity, _ in pairs(people) do
				if entity.Type=="Prisoner" then
					Object.SetProperty(this,"Tooltip", "Used by Utility Booth nr. "..this.HomeUID.."\n\nFIRE DETECTED!\nSending "..entity.Category.." "..entity.Type.." at "..string.sub(tostring(_),0,4).."m\nto the Evacuation Area")
					Object.ClearRouting(entity) --clearrouting doesn't seem to kill jobs, so have to do that manually
					entity.JobID=0 -- kill prisoners job
					entity.Station.i=0 -- clear the links to whatever he was working on
					entity.Station.u=0
					entity.StatusEffects.suppressed = 0 -- remove suppression so he can run fast
					entity.Needs.Evacuation = 100 -- give him some reasons to run
					entity.Needs.Safety = 100
				else
					Object.SetProperty(this,"Tooltip", "Used by Utility Booth nr. "..this.HomeUID.."\n\nFIRE DETECTED!\nEvacuating "..entity.Type.." at "..string.sub(tostring(_),0,4).."m")
					Object.ClearRouting(entity)
					Object.NavigateTo(entity, this.EvacPosX, this.EvacPosY)
				end
			end
		end
	else
		Object.SetProperty(this,"Tooltip", "tooltip_EvacuationAlarmSelective",this.HomeUID,"S")
	end
end

function CheckForFire()
	if next(MySprinklers) then
		for thatSprinkler, distance in pairs (MySprinklers) do
			if thatSprinkler.Active~=nil then
				if thatSprinkler.Active~=false then
					DoFireEvac()
				end
			else
				NumSprinklers=NumSprinklers-1
				this.SetInterfaceCaption("toggleFindSprinklers", "tooltip_button_scansprinklers",NumSprinklers,"X")
			end
		end
	end
end

function Update( timePassed )
	if timePerUpdate==0 then
		Range=this.Range
		FireAlarm = this.FireAlarm
		Interface.AddComponent(this,"toggleRange", "Button", "tooltip_button_ShowHideRange",this.Range,"X")
		if FireAlarm=="NO" then
			Interface.AddComponent(this,"toggleFireAlarm", "Button", "tooltip_button_alsofirealarm","tooltip_off","X")
		elseif FireAlarm=="YES" then 
			Interface.AddComponent(this,"toggleFireAlarm", "Button", "tooltip_button_alsofirealarm","tooltip_on","X")
			Interface.AddComponent(this,"toggleFindSprinklers", "Button", "tooltip_button_scansprinklers",NumSprinklers,"X")
			FindMySprinklers()
		end
		timePerUpdate=2.5
	end
	timeTot = timeTot + timePassed
	if timeTot>=timePerUpdate then
		timeTot=0
		if this.EvacType~=nil then
			Object.SetProperty(this,"Tooltip","Used by Utility Booth nr. "..this.HomeUID.."\n\nClick me for more options")
		else
			Object.SetProperty(this,"Tooltip", "tooltip_EvacuationAlarmSelective",this.HomeUID,"S")
		end
		local hasPower = ( this.Triggered or 0 ) > 0
		if hasPower then
			DoEvacuate()
		elseif this.FireAlarm=="YES" then
			CheckForFire()
		end
	end
end
