
function Create()
	newBooth = Object.Spawn("UtilityBooth",this.Pos.x,this.Pos.y-0.250000) -- UtilityBooth uses "height=3 and SpriteScale=0.5" instead of "height=1" like the inital controlbooth(M) sprite, so we have to realign it a bit to make it fall exactly in the position of ControlBoothMedium
	newSwitch = Object.Spawn("PowerSwitch",this.Pos.x,this.Pos.y-0.650000)
	newDummy = Object.Spawn("DummyPanel",0,0)
	newCP1 = Object.Spawn("ControlPanel",this.Pos.x-0.50000,this.Pos.y)
	newCP2 = Object.Spawn("ControlPanel",this.Pos.x+0.50000,this.Pos.y)
	Object.SetProperty(newSwitch,"Switch",false)
	Object.SetProperty(newSwitch,"HomeUID",me["id-uniqueId"])
	Object.SetProperty(newCP1,"HomeUID",newSwitch.HomeUID)
	Object.SetProperty(newCP2,"HomeUID",newSwitch.HomeUID)
	Object.SetProperty(newDummy,"HomeUID",newSwitch.HomeUID)
	Object.SetProperty(newBooth,"HomeUID",newSwitch.HomeUID)
	Object.SetProperty(newDummy,"Tooltip","Used by Utility Booth nr. "..newDummy.HomeUID.."\n\nIf you remove me, you should also remove my booth, or panels will be loaded in weird places.")
	Object.SetProperty(newBooth,"Slot2.i",newDummy.Id.i)
	Object.SetProperty(newBooth,"Slot2.u",newDummy.Id.u)
	Object.SetProperty(newBooth,"Slot5.i",newDummy.Id.i)
	Object.SetProperty(newBooth,"Slot5.u",newDummy.Id.u)
	Object.SetProperty(newBooth,"SubType",1)
	Object.SetProperty(newBooth,"SlotSize",1) -- the max Slot0-Slot7 number which can be filled with a utilitypanel by this booth
	Object.SetProperty(newBooth,"SwitchIsOn",false)
	--Object.SetProperty(newBooth,"Tooltip","S/N: "..newSwitch.HomeUID.."\n\n          INIT:\n   system starting up\n      please wait...\n\n")
	newBooth.Tooltip={"tooltip_initbooth",newSwitch.HomeUID,"X"}
	this.Delete()
end

-- Fill extra slots in a small booth: we need to since production.txt tells workmen to store stuff in a container which can vary in size
-- If we don't fill these unused slots with something, then workers will place panels in weird places in/around the booth, even though these slotnumbers are not defined in materials.txt
-- A small or medium booth has less slots that can be filled than a large booth, but since all slots are defined in production.txt we need to put some dummy stuff inside the unused slots.
-- For a medium booth we only need to fill the right display, so slots 2 and 5 get a dummy panel, representing the right display on a large booth
-- So we spawn a blank dummy panel with no image at x,y 0,0 and link it to the unused booth slots. Workmen will think those slots are loaded, and thus will only load panels in the slots where I want them to load.

-- Slotnumbers on utilitybooth: 
--    ----    ----    ----
--   |0  3|  |1  4|  |2  5|
--    ----    ----    ---- 
--   small   medium   large
