
-- This UtilityBooth gets spawned by ControlBooth, ControlBoothMedium or ControlBoothLarge

local timeTot=0

local ReadyToPower=false
local ReadyToSnitch=false
local ReadyToObey=false
local ReadyToGangSort0=false
local ReadyToGangSort1=false
local ReadyToGangSort2=false
local ReadyToEvac=false

local MyUtilityPanel = {}
local MyPagerPanel = {}
local MyDummyPanel = {}

local CoveredArea = {}

local UtilityPanelLoaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local PowerPanel1Loaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local SnitchPanel1Loaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local ObeyPanel1Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local GangPanel1Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local EvacPanel1Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local OtherPanel1Loaded  = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
-- panel1: left side of a display, panel2: right side of a display
local PagerPanelLoaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local PowerPanel2Loaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local SnitchPanel2Loaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local ObeyPanel2Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local GangPanel2Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local EvacPanel2Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
local OtherPanel2Loaded  = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }

local newTooltip = { [0] = "", [1] = "", [2] = "", [3] = "", [4] = "", [5] = "", [6] = "", [7] = "", [8] = "", [9] = "", [10] = "", [11] = "", [12] = "" }
local newSwitchTooltip = { [0] = "", [1] = "", [2] = "", [3] = "", [4] = "", [5] = "", [6] = "", [7] = "", [8] = "" }
local PanelSprites = { Workman = 0, Guard = 1, Dog  = 2, SnitchSorter = 6, Doctor = 10, Gardener = 11, Janitor = 12, Cook = 13 }

local currentSlotI = { [0] = 0, [1] = 0, [2] = 0, [3] = 0, [4] = 0, [5] = 0 }
local currentSlotU = { [0] = 0, [1] = 0, [2] = 0, [3] = 0, [4] = 0, [5] = 0 }
local priorSlotI = { [0] = 0, [1] = 0, [2] = 0, [3] = 0, [4] = 0, [5] = 0 }
local priorSlotU = { [0] = 0, [1] = 0, [2] = 0, [3] = 0, [4] = 0, [5] = 0 }

function Create()
	Object.SetProperty(this,"PriorSwitchState",true)
end

function InitBooth()
	Interface.AddComponent( this,"deleteMyBooth", "Button", "tooltip_button_deletebooth")
	Interface.AddComponent( this,"resetMyBooth", "Button", "tooltip_button_resetbooth")
	timePerUpdate=5
	MySwitchChanged()
	MySlotSize = Object.GetProperty(this,"SlotSize")
	if this.RNDSnitchTimer~=nil then	RandomSnitchTimer=Object.GetProperty(this,"RNDSnitchTimer");	timeToDoSnitchSort=RandomSnitchTimer	end
	if this.RNDObeyTimer~=nil then		RandomObeyTimer=Object.GetProperty(this,"RNDObeyTimer");		timeToDoObey=RandomObeyTimer	end
	if this.RNDEvacTimer~=nil then		RandomEvacTimer=Object.GetProperty(this,"RNDEvacTimer");		timeToDoEvac=RandomEvacTimer	end
	if this.RNDGang0Timer~=nil then		RandomGang0Timer=Object.GetProperty(this,"RNDGang0Timer");		timeToDoGang0=RandomGang0Timer	end
	if this.RNDGang1Timer~=nil then		RandomGang1Timer=Object.GetProperty(this,"RNDGang1Timer");		timeToDoGang1=RandomGang1Timer	end
	if this.RNDGang2Timer~=nil then		RandomGang2Timer=Object.GetProperty(this,"RNDGang2Timer");		timeToDoGang2=RandomGang2Timer	end
	if this.PriorSwitchState~=nil then
		priorSwitchState=Object.GetProperty(this,"PriorSwitchState")
	else
		priorSwitchState=true
	end
end

function Update( timePassed )
	if timePerUpdate==nil then
		InitBooth()
	end
	timeTot = timeTot + timePassed
	if timeTot>=timePerUpdate then
		timeTot=0
		if PanelsChanged() then
			FindMyPanels()
			UpdatePanelValues()
			StoreStatusInPanels()
			SetMyTooltips()
		end
		if MySwitchChanged() then
			Object.SetProperty(this,"PriorSwitchState",priorSwitchState)
			StoreStatusInPanels()
			SetMyTooltips()
		end
		if SwitchIsOn==false then
			
			if ReadyToPower==true then
				if this.powertooltip~=nil then --restore once after loadgame
					newTooltip[12]=Object.GetProperty(this,"powertooltip")
					Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
					Object.SetProperty(this,"powertooltip","")
					PowerIsOn=false
				elseif PowerIsOn==true or PowerIsOn==nil then
					PwrLight=""
					PwrSaw=""
					PwrPress=""
					PwrFridge=""
					PwrCooker=""
					PwrCctv=""
					PwrPhone=""
					PwrDCS=""
					PwrMetal=""
					if PowerLights=="YES" then TurnPowerOff("Light");					PwrLight="\n          "..tostring(PoweredObjects).." Lights" end
					if PowerSaw=="YES" then TurnPowerOff("WorkshopSaw");				PwrSaw="\n          "..tostring(PoweredObjects).." Workshop Saws" end				
					if PowerPress=="YES" then TurnPowerOff("WorkshopPress");			PwrPress="\n          "..tostring(PoweredObjects).." Workshop Presses" end				
					if PowerFridge=="YES" then TurnPowerOff("Fridge");					PwrFridge="\n          "..tostring(PoweredObjects).." Fridges" end				
					if PowerCooker=="YES" then TurnPowerOff("Cooker");					PwrCooker="\n          "..tostring(PoweredObjects).." Cookers" end				
					if PowerCCTV=="YES" then TurnPowerOff("CctvMonitor");				PwrCctv="\n          "..tostring(PoweredObjects).." CCTV Monitors" end				
					if PowerPhoneMonitor=="YES" then TurnPowerOff("PhoneMonitor");		PwrPhone="\n          "..tostring(PoweredObjects).." Phone Taps" end
					if PowerDoorControl=="YES" then TurnPowerOff("DoorControlSystem");	PwrDCS="\n          "..tostring(PoweredObjects).." Door Systems" end
					if PowerMetal=="YES" then TurnPowerOff("MetalDetector");			PwrMetal="\n          "..tostring(PoweredObjects).." Metal Detectors" end
					newTooltip[12] = "\n          Powered Off:"..PwrLight..""..PwrSaw..""..PwrPress..""..PwrFridge..""..PwrCooker..""..PwrMetal..""..PwrCctv..""..PwrPhone..""..PwrDCS..""
					Object.SetProperty(this,"powertooltip",newTooltip[12])
					Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
					PowerIsOn=false
				end
			end

			if TooltipFilled==true or TooltipFilled==nil then
				newTooltip[6] = ""
				newTooltip[7] = ""
				newTooltip[8] = ""
				newTooltip[9] = ""
				newTooltip[10] = ""
				newTooltip[11] = ""
				Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
				TooltipFilled=false
				if this.RNDSnitchTimer~=nil then	RandomSnitchTimer=Object.GetProperty(this,"RNDSnitchTimer");	timeToDoSnitchSort=RandomSnitchTimer	end
				if this.RNDObeyTimer~=nil then		RandomObeyTimer=Object.GetProperty(this,"RNDObeyTimer");		timeToDoObey=RandomObeyTimer	end
				if this.RNDEvacTimer~=nil then		RandomEvacTimer=Object.GetProperty(this,"RNDEvacTimer");		timeToDoEvac=RandomEvacTimer	end
				if this.RNDGang0Timer~=nil then		RandomGang0Timer=Object.GetProperty(this,"RNDGang0Timer");		timeToDoGang0=RandomGang0Timer	end
				if this.RNDGang1Timer~=nil then		RandomGang1Timer=Object.GetProperty(this,"RNDGang1Timer");		timeToDoGang1=RandomGang1Timer	end
				if this.RNDGang2Timer~=nil then		RandomGang2Timer=Object.GetProperty(this,"RNDGang2Timer");		timeToDoGang2=RandomGang2Timer	end
			end
		end
	end
	if SwitchIsOn==true and (ReadyToSnitch==true or ReadyToObey==true or ReadyToEvac==true or ReadyToGangSort0==true or ReadyToGangSort1==true or ReadyToGangSort2==true or ReadyToPower==true) then
		DoSomeAction(timePassed)
	end
end

function DoSomeAction(timePassed)

	if timeToDoSnitchSort~=nil then
		timeToDoSnitchSort = timeToDoSnitchSort - timePassed
		if ReadyToSnitch==true and timeToDoSnitchSort<=2 then
			newTooltip[6] = "\nNEXT SNITCH SWEEP IN "..string.sub(tostring(timeToDoSnitchSort),0,4)..""
			Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
		end
		if timeToDoSnitchSort<=0 then 
			timeToDoSnitchSort=RandomSnitchTimer
			if ReadyToSnitch==true then
				DoSnitchSorting()
			end
		end
	end

	if timeToDoObey~=nil then
		timeToDoObey = timeToDoObey - timePassed
		if ReadyToObey==true and timeToDoObey<=2 then
			newTooltip[7] = "\nNEXT OBEY SWEEP IN "..string.sub(tostring(timeToDoObey),0,4)..""
			Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
		end
		if timeToDoObey<=0 then
			timeToDoObey=RandomObeyTimer
			if ReadyToObey==true then
				DoObeyMachine()
			end
		end
	end
		
	if timeToDoEvac~=nil then
		timeToDoEvac = timeToDoEvac - timePassed
		if ReadyToEvac==true and MySwitch.EvacTestRun=="NO" and timeToDoEvac<=2 then
			newTooltip[8] = "\nNEXT EVAC SWEEP IN "..string.sub(tostring(timeToDoEvac),0,4)..""
			Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
		end
		if timeToDoEvac<=0 then
			timeToDoEvac=RandomEvacTimer
			if ReadyToEvac==true then
				DoEvacuation()
			end
		end
	end

	if timeToDoGang0~=nil then
		timeToDoGang0 = timeToDoGang0 - timePassed
		if ReadyToGangSort0==true and timeToDoGang0<=2 then
			newTooltip[9] = "\nNEXT GANG SWEEP IN "..string.sub(tostring(timeToDoGang0),0,4).."\n"
			Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
		end
		if timeToDoGang0<=0 then
			timeToDoGang0=RandomGang0Timer
			if ReadyToGangSort0==true then
				DoGangSorting0()
			end
		end
	end

	if timeToDoGang1~=nil then
		timeToDoGang1 = timeToDoGang1 - timePassed
		if ReadyToGangSort1==true and timeToDoGang1<=2 then
			newTooltip[10] = "\nNEXT GANG SWEEP IN "..string.sub(tostring(timeToDoGang1),0,4).."\n"
			Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
		end
		if timeToDoGang1<=0 then
			timeToDoGang1=RandomGang1Timer
			if ReadyToGangSort1==true then
				DoGangSorting1()
			end
		end
	end
	
	if timeToDoGang2~=nil then
		timeToDoGang2 = timeToDoGang2 - timePassed
		if ReadyToGangSort2==true and timeToDoGang2<=2 then
			newTooltip[11] = "\nNEXT GANG SWEEP IN "..string.sub(tostring(timeToDoGang2),0,4).."\n"
			Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
		end
		if timeToDoGang2<=0 then
			timeToDoGang2=RandomGang2Timer
			if ReadyToGangSort2==true then
				DoGangSorting2()
			end
		end
	end
	
	if ReadyToPower==true then
		if this.powertooltip~=nil then
			newTooltip[12]=Object.GetProperty(this,"powertooltip")
			Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
			Object.SetProperty(this,"powertooltip","")
			PowerIsOn=true
		elseif PowerIsOn==false or PowerIsOn==nil then
			PwrLight=""
			PwrSaw=""
			PwrPress=""
			PwrFridge=""
			PwrCooker=""
			PwrCctv=""
			PwrPhone=""
			PwrDCS=""
			PwrMetal=""
			if PowerLights=="YES" then TurnPowerOn("Light");					PwrLight="\n          "..tostring(PoweredObjects).." Lights" end
			if PowerSaw=="YES" then TurnPowerOn("WorkshopSaw");					PwrSaw="\n          "..tostring(PoweredObjects).." Workshop Saws" end				
			if PowerPress=="YES" then TurnPowerOn("WorkshopPress");				PwrPress="\n          "..tostring(PoweredObjects).." Workshop Presses" end				
			if PowerFridge=="YES" then TurnPowerOn("Fridge");					PwrFridge="\n          "..tostring(PoweredObjects).." Fridges" end				
			if PowerCooker=="YES" then TurnPowerOn("Cooker");					PwrCooker="\n          "..tostring(PoweredObjects).." Cookers" end				
			if PowerCCTV=="YES" then TurnPowerOn("CctvMonitor");				PwrCctv="\n          "..tostring(PoweredObjects).." CCTV Monitors" end				
			if PowerPhoneMonitor=="YES" then TurnPowerOn("PhoneMonitor");		PwrPhone="\n          "..tostring(PoweredObjects).." Phone Taps" end
			if PowerDoorControl=="YES" then TurnPowerOn("DoorControlSystem");	PwrDCS="\n          "..tostring(PoweredObjects).." Door Systems" end
			if PowerMetal=="YES" then TurnPowerOn("MetalDetector");				PwrMetal="\n          "..tostring(PoweredObjects).." Metal Detectors" end
			newTooltip[12] = "\n          Powered On:"..PwrLight..""..PwrSaw..""..PwrPress..""..PwrFridge..""..PwrCooker..""..PwrMetal..""..PwrCctv..""..PwrPhone..""..PwrDCS..""
			Object.SetProperty(this,"powertooltip",newTooltip[12])
			Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
			PowerIsOn=true
		end
	end
end

function MySwitchChanged()
	local ChangeDetected=false
	if MySwitch==nil then
		FindMySwitch()
	end
	if MySwitch.Switch==false then
		SwitchIsOn = false
	else
		SwitchIsOn = true
	end
	if priorSwitchState~=MySwitch.Switch then
		ChangeDetected=true
		if SwitchIsOn==true then
			--Game.DebugOut("---Power Switch is ON---")
			if this.SubType~=this.SlotSize+3 then this.SubType=this.SlotSize+3 end -- turn booth display bright blue
		else
			--Game.DebugOut("---Power Switch is OFF---")
			if this.SubType~=this.SlotSize then this.SubType=this.SlotSize end --turn booth display dark
		end
	end
	priorSwitchState=MySwitch.Switch
	return ChangeDetected
end

function FindMySwitch()
	local Switches = this.GetNearbyObjects('PowerSwitch',2)
	for thatSwitch, distance in pairs (Switches) do
		if thatSwitch.HomeUID==this.HomeUID then
			--Game.DebugOut("---Found my switch---")
			MySwitch=thatSwitch
		end
	end
	Switches = nil
end

function PanelsChanged()
	local ChangeDetected=false
	local n=0
	currentSlotI[0] = Object.GetProperty(this,"Slot0.i")
	currentSlotI[1] = Object.GetProperty(this,"Slot1.i")
	currentSlotI[2] = Object.GetProperty(this,"Slot2.i")
	currentSlotI[3] = Object.GetProperty(this,"Slot3.i")
	currentSlotI[4] = Object.GetProperty(this,"Slot4.i")
	currentSlotI[5] = Object.GetProperty(this,"Slot5.i")
	currentSlotU[0] = Object.GetProperty(this,"Slot0.u")
	currentSlotU[1] = Object.GetProperty(this,"Slot1.u")
	currentSlotU[2] = Object.GetProperty(this,"Slot2.u")
	currentSlotU[3] = Object.GetProperty(this,"Slot3.u")
	currentSlotU[4] = Object.GetProperty(this,"Slot4.u")
	currentSlotU[5] = Object.GetProperty(this,"Slot5.u")
	for n=0,5 do
		if priorSlotI[n]~=currentSlotI[n] or priorSlotU[n]~=currentSlotU[n] then
			ChangeDetected=true
		end
		if currentSlotI[n]~=nil then
			priorSlotI[n]=currentSlotI[n]
			priorSlotU[n]=currentSlotU[n]
		end
	end
	--if ChangeDetected==true then Game.DebugOut("---Update panels required---") end
	return ChangeDetected
end

function StoreStatusInPanels()
	--Game.DebugOut("==StoreStatusInPanels STARTING==")
	MySlotSize = this.SlotSize
	for i=0,MySlotSize do
		if OtherPanel1Loaded[i]~=true then -- if no eyecandy panel is installed, then we need to do some more stuff, else we just sit here and do nothing
			if UtilityPanelLoaded[i]==true then -- if utility is loaded and a pager panel as well, then takeover the settings in order to update the status of the powerswitch
				if PowerPanel1Loaded[i]==true then -- but first let's check if a Power controller has been installed
					if PowerPanel2Loaded[i]==true then
						--Game.DebugOut("Storing switch status in POWER panel i="..i.."")
						Object.SetProperty(MyUtilityPanel[i],"SwitchIsOn",SwitchIsOn) -- store status of the powerswitch in snitchpanel
						if MyUtilityPanel[i].SwitchIsOn~=true then
							--Object.SetProperty(MyUtilityPanel[i],"SubType",8) -- show the 'OFFLINE' display
							Object.SetProperty(MyUtilityPanel[i],"SubType",20) -- show the normal Power display
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_offline")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_offline")
							--newTooltip[12] = ""
						else
							Object.SetProperty(MyUtilityPanel[i],"SubType",20) -- show SnitchPanel display and do snitch sorting
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_online")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_online")
						end
					end
				elseif SnitchPanel1Loaded[i]==true then -- let's check if a snitch sorter has been installed
					if SnitchPanel2Loaded[i]==true then
						--Game.DebugOut("Storing switch status in SNITCH panel i="..i.."")
						Object.SetProperty(MyUtilityPanel[i],"SwitchIsOn",SwitchIsOn) -- store status of the powerswitch in snitchpanel
						if MyUtilityPanel[i].SwitchIsOn~=true then
							--Object.SetProperty(MyUtilityPanel[i],"SubType",8) -- show the 'OFFLINE' display
							Object.SetProperty(MyUtilityPanel[i],"SubType",6) -- show the normal snitch display
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_offline")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_offline")
							newTooltip[6] = ""
						else
							Object.SetProperty(MyUtilityPanel[i],"SubType",6) -- show SnitchPanel display and do snitch sorting
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_online")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_online")
						end
					end
				elseif ObeyPanel1Loaded[i]==true then -- let's check if a Obey has been installed
					if ObeyPanel2Loaded[i]==true then
						--Game.DebugOut("Storing switch status in OBEY panel i="..i.."")
						Object.SetProperty(MyUtilityPanel[i],"SwitchIsOn",SwitchIsOn)  -- store status of the powerswitch in Obeypanel
						if MyUtilityPanel[i].SwitchIsOn~=true then
							--Object.SetProperty(MyUtilityPanel[i],"SubType",8) -- show the 'OFFLINE' display
							Object.SetProperty(MyUtilityPanel[i],"SubType",9) -- show the normal obey display
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_offline")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_offline")
							newTooltip[7] = ""
						else
							Object.SetProperty(MyUtilityPanel[i],"SubType",9) -- show OBEY display
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_online")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_online")
						end
					end
				elseif GangPanel1Loaded[i]==true then -- let's check if a Gang Sorter has been installed
					if GangPanel2Loaded[i]==true then
						--Game.DebugOut("Storing switch status in GANG panel i="..i.."")
						Object.SetProperty(MyUtilityPanel[i],"SwitchIsOn",SwitchIsOn) -- store status of the powerswitch in Gangpanel
						if MyUtilityPanel[i].SwitchIsOn~=true then
							--Object.SetProperty(MyUtilityPanel[i],"SubType",8) -- show the 'OFFLINE' display
							Object.SetProperty(MyUtilityPanel[i],"SubType",MyUtilityPanel[i].GangId+15) -- show the normal gang display
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_offline")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_offline")
							newTooltip[11] = ""
						else
							Object.SetProperty(MyUtilityPanel[i],"SubType",MyUtilityPanel[i].GangId+15) -- show Gang display
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_online")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_online")
						end
					end
				elseif EvacPanel1Loaded[i]==true then -- let's check if an Evac has been installed
					if EvacPanel2Loaded[i]==true then
						--Game.DebugOut("Storing switch status in EVAC panel i="..i.."")
						Object.SetProperty(MyUtilityPanel[i],"SwitchIsOn",SwitchIsOn) -- store status of the powerswitch in Evacpanel
						if MyUtilityPanel[i].SwitchIsOn~=true then
							Object.SetProperty(MyUtilityPanel[i],"SubType",14) -- show the normal Evac display
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_offline")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_offline")
							newTooltip[8] = ""
						else
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","tooltip_online")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","tooltip_online")
						end
					end
				else
					if PowerPanel2Loaded[i]==false and EvacPanel2Loaded[i]==false and ObeyPanel2Loaded[i]==false and SnitchPanel2Loaded[i]==false and GangPanel2Loaded[i]==false and PagerPanelLoaded[i]==true then -- it wasn't an Evac nor Obey nor snitch sorter, so let's get the pager values	
						--Game.DebugOut("Storing switch status in STAFF panel i="..i.."")
						Object.SetProperty(MyUtilityPanel[i],"SwitchIsOn",SwitchIsOn) -- store status of the powerswitch in utilitypanel
						if MyUtilityPanel[i].SwitchIsOn==true and MyUtilityPanel[i].CallCompleted==false and MyUtilityPanel[i].JobID==nil then -- the powerswitch is on and a call job is active
							--Game.DebugOut("Showing CALL sprite i="..i.."")
							Object.SetProperty(MyUtilityPanel[i],"SubType",3) -- show the 'CALL' display
						else
							--Game.DebugOut("Showing DEFAULT sprite i="..i.."")
							Object.SetProperty(MyUtilityPanel[i],"SubType",PanelSprites[MyUtilityPanel[i].PanelType]) -- show Workman, Guard, Dog display
							Object.SetProperty(MyUtilityPanel[i],"Tooltip","")
							Object.SetProperty(MyPagerPanel[i],"Tooltip","")
						end
						if MyUtilityPanel[i].SwitchIsOn==true then
							if MyUtilityPanel[i].CallCompleted==false and MyUtilityPanel[i].PanelType~="Evac (L)" then
								local jobID = MyUtilityPanel[i].JobID  -- JobID spelled like JobID and not like JobId so the value is in the ScriptSystem instead of the object itself.
								if jobID==nil then
									if MyUtilityPanel[i].PanelType=="Dog" then
										--Spawn Dogs
										Object.Sound("UtilityBooth","StartCalling")
										Object.CreateJob(MyUtilityPanel[i],"ReleaseDogs")
									else
										Object.Sound("UtilityBooth","StartCalling")
										--Spawn Staff
										Object.CreateJob(MyUtilityPanel[i],"CallStaff")
									end
								end
							end
						else
							if MyUtilityPanel[i].CallCompleted==true and MyUtilityPanel[i].PanelType~="Evac (L)" then
								--Game.DebugOut("Showing SACK sprite i="..i.."")
								Object.SetProperty(MyUtilityPanel[i],"SubType",4) -- show Sack staff display
								--Delete all staff linked to this panel
								Object.CreateJob(MyUtilityPanel[i],"DeleteStaff")
							end
						end
					else -- pager not present or has been removed, so reset utilitypanel
						newSwitchTooltip[i]=""
						newSwitchTooltip[i+3] = ""
						newSwitchTooltip[8] = ""
						--Game.DebugOut("Panel deleted, resetting utilitypanel i="..i.."")
						Object.SetProperty(MyUtilityPanel[i],"xTimes",0)
						Object.SetProperty(MyUtilityPanel[i],"SwitchIsOn",false)
						Object.SetProperty(MyUtilityPanel[i],"SubType",5) -- show the 'No Pager' display until a pager panel is found
					end
				end
			else -- else do nothing at all, we don't care if there is a pagerpanel loaded without a utilitypanel
				--Game.DebugOut("did nothing H i="..i.."")
			end
		else -- else there was just eyecandy loaded so we do nothing
			--Game.DebugOut("did nothing G i="..i.."")
		end
	end
	--Game.DebugOut("==StoreStatusInPanels FINISHED==")
end
		

-- FUNCTIONS FOR UTILITYPANEL--

function togglePowerRangePlusClicked()
	if PowerRange<=49 then
		if CoveredByPower==true then
			HideCoveredArea("Power")
			CoveredByPower=false
		end
		PowerRange=PowerRange+2
		Object.SetProperty(this,"PowerRange",PowerRange)
		this.SetInterfaceCaption("togglePowerRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredPowerArea", "tooltip_button_ShowHideRange",this.PowerRange,"X")
		this.SetInterfaceCaption("togglePowerRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.PowerRange,"Power")
		CoveredByPower=true
	end
end

function togglePowerRangeMinusClicked()
	if PowerRange>=5 then
		if CoveredByPower==true then
			HideCoveredArea("Power")
			CoveredByPower=false
		end
		PowerRange=PowerRange-2
		Object.SetProperty(this,"PowerRange",PowerRange)
		this.SetInterfaceCaption("togglePowerRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredPowerArea", "tooltip_button_ShowHideRange",this.PowerRange,"X")
		this.SetInterfaceCaption("togglePowerRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.PowerRange,"Power")
		CoveredByPower=true
	end
end

function toggleSnitchRangePlusClicked()
	if SnitchRange<=49 then
		if CoveredBySnitch==true then
			HideCoveredArea("Snitch")
			CoveredBySnitch=false
		end
		SnitchRange=SnitchRange+2
		Object.SetProperty(this,"SnitchRange",SnitchRange)
		this.SetInterfaceCaption("toggleSnitchRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredSnitchArea", "tooltip_button_ShowHideRange",this.SnitchRange,"X")
		this.SetInterfaceCaption("toggleSnitchRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.SnitchRange,"Snitch")
		CoveredBySnitch=true
	end
end

function toggleSnitchRangeMinusClicked()
	if SnitchRange>=5 then
		if CoveredBySnitch==true then
			HideCoveredArea("Snitch")
			CoveredBySnitch=false
		end
		SnitchRange=SnitchRange-2
		Object.SetProperty(this,"SnitchRange",SnitchRange)
		this.SetInterfaceCaption("toggleSnitchRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredSnitchArea", "tooltip_button_ShowHideRange",this.SnitchRange,"X")
		this.SetInterfaceCaption("toggleSnitchRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.SnitchRange,"Snitch")
		CoveredBySnitch=true
	end
end

function toggleObeyRangePlusClicked()
	if ObeyRange<=49 then
		if CoveredByObey==true then
			HideCoveredArea("Obey")
			CoveredByObey=false
		end
		ObeyRange=ObeyRange+2
		Object.SetProperty(this,"ObeyRange",ObeyRange)
		this.SetInterfaceCaption("toggleObeyRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredObeyArea", "tooltip_button_ShowHideRange",this.ObeyRange,"X")
		this.SetInterfaceCaption("toggleObeyRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.ObeyRange,"Obey")
		CoveredByObey=true
	end
end

function toggleObeyRangeMinusClicked()
	if ObeyRange>=5 then
		if CoveredByObey==true then
			HideCoveredArea("Obey")
			CoveredByObey=false
		end
		ObeyRange=ObeyRange-2
		Object.SetProperty(this,"ObeyRange",ObeyRange)
		this.SetInterfaceCaption("toggleObeyRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredObeyArea", "tooltip_button_ShowHideRange",this.ObeyRange,"X")
		this.SetInterfaceCaption("toggleObeyRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.ObeyRange,"Obey")
		CoveredByObey=true
	end
end

function toggleEvacRangePlusClicked()
	if EvacRange<=49 then
		if CoveredByEvac==true then
			HideCoveredArea("Evac")
			CoveredByEvac=false
		end
		EvacRange=EvacRange+2
		Object.SetProperty(this,"EvacRange",EvacRange)
		this.SetInterfaceCaption("toggleEvacRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredEvacArea", "tooltip_button_ShowHideRange",this.EvacRange,"X")
		this.SetInterfaceCaption("toggleEvacRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.EvacRange,"Evac")
		CoveredByEvac=true
	end
end

function toggleEvacRangeMinusClicked()
	if EvacRange>=5 then
		if CoveredByEvac==true then
			HideCoveredArea("Evac")
			CoveredByEvac=false
		end
		EvacRange=EvacRange-2
		Object.SetProperty(this,"EvacRange",EvacRange)
		this.SetInterfaceCaption("toggleEvacRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredEvacArea", "tooltip_button_ShowHideRange",this.EvacRange,"X")
		this.SetInterfaceCaption("toggleEvacRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.EvacRange,"Evac")
		CoveredByEvac=true
	end
end

function toggleGangRange0PlusClicked()
	if GangRange0<=49 then
		if CoveredByGang0==true then
			HideCoveredArea("Gang"..tostring(this.GangId0-2).."A")
			CoveredByGang0=false
		end
		GangRange0=GangRange0+2
		Object.SetProperty(this,"GangRange0",GangRange0)
		this.SetInterfaceCaption("toggleGangRange0Plus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredGang0Area", "tooltip_button_ShowHideRange",this.GangRange0,"X")
		this.SetInterfaceCaption("toggleGangRange0Minus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.GangRange0,"Gang"..tostring(this.GangId0-2).."A")
		CoveredByGang0=true
	end
end

function toggleGangRange1PlusClicked()
	if GangRange1<=49 then
		if CoveredByGang1==true then
			HideCoveredArea("Gang"..tostring(this.GangId1-2).."B")
			CoveredByGang1=false
		end
		GangRange1=GangRange1+2
		Object.SetProperty(this,"GangRange1",GangRange1)
		this.SetInterfaceCaption("toggleGangRange1Plus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredGang1Area", "tooltip_button_ShowHideRange",this.GangRange1,"X")
		this.SetInterfaceCaption("toggleGangRange1Minus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.GangRange1,"Gang"..tostring(this.GangId1-2).."B")
		CoveredByGang1=true
	end
end

function toggleGangRange2PlusClicked()
	if GangRange2<=49 then
		if CoveredByGang2==true then
			HideCoveredArea("Gang"..tostring(this.GangId2-2).."C")
			CoveredByGang2=false
		end
		GangRange2=GangRange2+2
		Object.SetProperty(this,"GangRange2",GangRange2)
		this.SetInterfaceCaption("toggleGangRange2Plus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredGang2Area", "tooltip_button_ShowHideRange",this.GangRange2,"X")
		this.SetInterfaceCaption("toggleGangRange2Minus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.GangRange2,"Gang"..tostring(this.GangId2-2).."C")
		CoveredByGang2=true
	end
end

function toggleGangRange0MinusClicked()
	if GangRange0>=5 then
		if CoveredByGang0==true then
			HideCoveredArea("Gang"..tostring(this.GangId0-2).."A")
			CoveredByGang0=false
		end
		GangRange0=GangRange0-2
		Object.SetProperty(this,"GangRange0",GangRange0)
		this.SetInterfaceCaption("toggleGangRange0Plus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredGang0Area", "tooltip_button_ShowHideRange",this.GangRange0,"X")
		this.SetInterfaceCaption("toggleGangRange0Minus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.GangRange0,"Gang"..tostring(this.GangId0-2).."A")
		CoveredByGang0=true
	end
end

function toggleGangRange1MinusClicked()
	if GangRange1>=5 then
		if CoveredByGang1==true then
			HideCoveredArea("Gang"..tostring(this.GangId1-2).."B")
			CoveredByGang1=false
		end
		GangRange1=GangRange1-2
		Object.SetProperty(this,"GangRange1",GangRange1)
		this.SetInterfaceCaption("toggleGangRange1Plus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredGang1Area", "tooltip_button_ShowHideRange",this.GangRange1,"X")
		this.SetInterfaceCaption("toggleGangRange1Minus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.GangRange1,"Gang"..tostring(this.GangId1-2).."B")
		CoveredByGang1=true
	end
end

function toggleGangRange2MinusClicked()
	if GangRange2>=5 then
		if CoveredByGang2==true then
			HideCoveredArea("Gang"..tostring(this.GangId2-2).."C")
			CoveredByGang2=false
		end
		GangRange2=GangRange2-2
		Object.SetProperty(this,"GangRange2",GangRange2)
		this.SetInterfaceCaption("toggleGangRange2Plus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredGang2Area", "tooltip_button_ShowHideRange",this.GangRange2,"X")
		this.SetInterfaceCaption("toggleGangRange2Minus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.GangRange2,"Gang"..tostring(this.GangId2-2).."C")
		CoveredByGang2=true
	end
end

function toggleUndoSectionToGang0Clicked()
	if mySectionToGangListNumber0>0 then
		SortGangs0="GangToSection"
		button_txt="tooltip_"..string.lower(SortGangs0)
		Object.SetProperty(this,"GangSorter0",SortGangs0)
		this.SetInterfaceCaption("toggleGangSorter0", button_txt)
		local prisoners0 = this.GetNearbyObjects('Prisoner',500)
		for thatPrisoner, distance in pairs (prisoners0) do
			for i=0, mySectionToGangListNumber0 do
				if thatPrisoner.Id.u==mySectionToGangList0[i] and thatPrisoner.Gang.Id~=nil then
					thatPrisoner.Gang.Id=0
					thatPrisoner.Gang.Rank=nil
					thatPrisoner.Gang.Recruitment=nil
					SalvagedPrisoners0=SalvagedPrisoners0-1
				end
			end
		end
		prisoners0=nil
		this.SetInterfaceCaption("toggleUndoSectionToGang0", "tooltip_button_undo",SalvagedPrisoners0,"X")
		if SalvagedPrisoners0==0 then
			mySectionToGangListNumber0=0
			mySectionToGangList0={}
			Interface.RemoveComponent(this,"toggleUndoSectionToGang0", "Button", "tooltip_button_undo",SalvagedPrisoners0,"X")
		end
	end
end

function toggleUndoSectionToGang1Clicked()
	if mySectionToGangListNumber1>0 then
		SortGangs1="GangToSection"
		button_txt="tooltip_"..string.lower(SortGangs1)
		Object.SetProperty(this,"GangSorter1",SortGangs1)
		this.SetInterfaceCaption("toggleGangSorter1", button_txt)
		local prisoners1 = this.GetNearbyObjects('Prisoner',500)
		for thatPrisoner, distance in pairs (prisoners1) do
			for i=0, mySectionToGangListNumber1 do
				if thatPrisoner.Id.u==mySectionToGangList1[i] and thatPrisoner.Gang.Id~=nil then
					thatPrisoner.Gang.Id=0
					thatPrisoner.Gang.Rank=nil
					thatPrisoner.Gang.Recruitment=nil
					SalvagedPrisoners1=SalvagedPrisoners1-1
				end
			end
		end
		prisoners1=nil
		this.SetInterfaceCaption("toggleUndoSectionToGang1", "tooltip_button_undo",SalvagedPrisoners1,"X")
		if SalvagedPrisoners1==0 then
			mySectionToGangListNumber1=0
			mySectionToGangList1={}
			Interface.RemoveComponent(this,"toggleUndoSectionToGang1", "Button", "tooltip_button_undo",SalvagedPrisoners1,"X")
		end
	end
end

function toggleUndoSectionToGang2Clicked()
	if mySectionToGangListNumber2>0 then
		SortGangs2="GangToSection"
		button_txt="tooltip_"..string.lower(SortGangs2)
		Object.SetProperty(this,"GangSorter2",SortGangs2)
		this.SetInterfaceCaption("toggleGangSorter2", button_txt)
		local prisoners2 = this.GetNearbyObjects('Prisoner',500)
		for thatPrisoner, distance in pairs (prisoners2) do
			for i=0, mySectionToGangListNumber2 do
				if thatPrisoner.Id.u==mySectionToGangList2[i] and thatPrisoner.Gang.Id~=nil then
					thatPrisoner.Gang.Id=0
					thatPrisoner.Gang.Rank=nil
					thatPrisoner.Gang.Recruitment=nil
					SalvagedPrisoners2=SalvagedPrisoners2-1
				end
			end
		end
		prisoners2=nil
		this.SetInterfaceCaption("toggleUndoSectionToGang2", "tooltip_button_undo",SalvagedPrisoners2,"X")
		if SalvagedPrisoners2==0 then
			mySectionToGangListNumber2=0
			mySectionToGangList2={}
			Interface.RemoveComponent(this,"toggleUndoSectionToGang2", "Button", "tooltip_button_undo",SalvagedPrisoners2,"X")
		end
	end
end

function toggleUpdateObjectsClicked()
	PwrLight=""
	PwrSaw=""
	PwrPress=""
	PwrFridge=""
	PwrCooker=""
	PwrCctv=""
	PwrPhone=""
	PwrDCS=""
	PwrMetal=""
	if SwitchIsOn==true then
		if PowerLights=="YES" then TurnPowerOn("Light");					PwrLight="\n          "..tostring(PoweredObjects).." Lights" end
		if PowerSaw=="YES" then TurnPowerOn("WorkshopSaw");					PwrSaw="\n          "..tostring(PoweredObjects).." Workshop Saws" end				
		if PowerPress=="YES" then TurnPowerOn("WorkshopPress");				PwrPress="\n          "..tostring(PoweredObjects).." Workshop Presses" end				
		if PowerFridge=="YES" then TurnPowerOn("Fridge");					PwrFridge="\n          "..tostring(PoweredObjects).." Fridges" end				
		if PowerCooker=="YES" then TurnPowerOn("Cooker");					PwrCooker="\n          "..tostring(PoweredObjects).." Cookers" end				
		if PowerCCTV=="YES" then TurnPowerOn("CctvMonitor");				PwrCctv="\n          "..tostring(PoweredObjects).." CCTV Monitors" end				
		if PowerPhoneMonitor=="YES" then TurnPowerOn("PhoneMonitor");		PwrPhone="\n          "..tostring(PoweredObjects).." Phone Taps" end
		if PowerDoorControl=="YES" then TurnPowerOn("DoorControlSystem");	PwrDCS="\n          "..tostring(PoweredObjects).." Door Systems" end
		if PowerMetal=="YES" then TurnPowerOn("MetalDetector");				PwrMetal="\n          "..tostring(PoweredObjects).." Metal Detectors" end
		newTooltip[12] = "\n          Powered On:"..PwrLight..""..PwrSaw..""..PwrPress..""..PwrFridge..""..PwrCooker..""..PwrMetal..""..PwrCctv..""..PwrPhone..""..PwrDCS..""
	else
		if PowerLights=="YES" then TurnPowerOff("Light");					PwrLight="\n          "..tostring(PoweredObjects).." Lights" end
		if PowerSaw=="YES" then TurnPowerOff("WorkshopSaw");				PwrSaw="\n          "..tostring(PoweredObjects).." Workshop Saws" end				
		if PowerPress=="YES" then TurnPowerOff("WorkshopPress");			PwrPress="\n          "..tostring(PoweredObjects).." Workshop Presses" end				
		if PowerFridge=="YES" then TurnPowerOff("Fridge");					PwrFridge="\n          "..tostring(PoweredObjects).." Fridges" end				
		if PowerCooker=="YES" then TurnPowerOff("Cooker");					PwrCooker="\n          "..tostring(PoweredObjects).." Cookers" end				
		if PowerCCTV=="YES" then TurnPowerOff("CctvMonitor");				PwrCctv="\n          "..tostring(PoweredObjects).." CCTV Monitors" end				
		if PowerPhoneMonitor=="YES" then TurnPowerOff("PhoneMonitor");		PwrPhone="\n          "..tostring(PoweredObjects).." Phone Taps" end
		if PowerDoorControl=="YES" then TurnPowerOff("DoorControlSystem");	PwrDCS="\n          "..tostring(PoweredObjects).." Door Systems" end
		if PowerMetal=="YES" then TurnPowerOff("MetalDetector");				PwrMetal="\n          "..tostring(PoweredObjects).." Metal Detectors" end
		newTooltip[12] = "\n          Powered Off:"..PwrLight..""..PwrSaw..""..PwrPress..""..PwrFridge..""..PwrCooker..""..PwrMetal..""..PwrCctv..""..PwrPhone..""..PwrDCS..""
	end
	Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	this.SetInterfaceCaption("toggleUpdateObjects", "tooltip_button_updateobjects")
end

function togglePowerLightsClicked()
	if PowerLights=="YES" then PowerLights="NO" else PowerLights="YES" end
	button_txt="tooltip_"..string.lower(PowerLights)
	Object.SetProperty(this,"PowerLights",PowerLights)
	this.SetInterfaceCaption("togglePowerLights", "tooltip_button_powerlights",button_txt,"X")
end

function togglePowerSawClicked()
	if PowerSaw=="YES" then PowerSaw="NO" else PowerSaw="YES" end
	button_txt="tooltip_"..string.lower(PowerSaw)
	Object.SetProperty(this,"PowerSaw",PowerSaw)
	this.SetInterfaceCaption("togglePowerSaw", "tooltip_button_powersaw",button_txt,"X")
end

function togglePowerPressClicked()
	if PowerPress=="YES" then PowerPress="NO" else PowerPress="YES" end
	button_txt="tooltip_"..string.lower(PowerPress)
	Object.SetProperty(this,"PowerPress",PowerPress)
	this.SetInterfaceCaption("togglePowerPress", "tooltip_button_powerpress",button_txt,"X")
end

function togglePowerFridgeClicked()
	if PowerFridge=="YES" then PowerFridge="NO" else PowerFridge="YES" end
	button_txt="tooltip_"..string.lower(PowerFridge)
	Object.SetProperty(this,"PowerFridge",PowerFridge)
	this.SetInterfaceCaption("togglePowerFridge", "tooltip_button_powerfridge",button_txt,"X")
end

function togglePowerCookerClicked()
	if PowerCooker=="YES" then PowerCooker="NO" else PowerCooker="YES" end
	button_txt="tooltip_"..string.lower(PowerCooker)
	Object.SetProperty(this,"PowerCooker",PowerCooker)
	this.SetInterfaceCaption("togglePowerCooker", "tooltip_button_powercooker",button_txt,"X")
end

function togglePowerMetalClicked()
	if PowerMetal=="YES" then PowerMetal="NO" else PowerMetal="YES" end
	button_txt="tooltip_"..string.lower(PowerMetal)
	Object.SetProperty(this,"PowerMetal",PowerMetal)
	this.SetInterfaceCaption("togglePowerMetal", "tooltip_button_PowerMetal",button_txt,"X")
end

function togglePowerCCTVClicked()
	if PowerCCTV=="YES" then PowerCCTV="NO" else PowerCCTV="YES" end
	button_txt="tooltip_"..string.lower(PowerCCTV)
	Object.SetProperty(this,"PowerCCTV",PowerCCTV)
	this.SetInterfaceCaption("togglePowerCCTV", "tooltip_button_PowerCCTV",button_txt,"X")
end

function togglePowerDoorControlClicked()
	if PowerDoorControl=="YES" then PowerDoorControl="NO" else PowerDoorControl="YES" end
	button_txt="tooltip_"..string.lower(PowerDoorControl)
	Object.SetProperty(this,"PowerDoorControl",PowerDoorControl)
	this.SetInterfaceCaption("togglePowerDoorControl", "tooltip_button_PowerDoorControl",button_txt,"X")
end

function togglePowerPhoneMonitorClicked()
	if PowerPhoneMonitor=="YES" then PowerPhoneMonitor="NO" else PowerPhoneMonitor="YES" end
	button_txt="tooltip_"..string.lower(PowerPhoneMonitor)
	Object.SetProperty(this,"PowerPhoneMonitor",PowerPhoneMonitor)
	this.SetInterfaceCaption("togglePowerPhoneMonitor", "tooltip_button_PowerPhoneMonitor",button_txt,"X")
end

function toggleEvacTestRunClicked()
	if EvacTestRun=="YES" then EvacTestRun="NO" else EvacTestRun="YES" end
	button_txt="tooltip_"..string.lower(EvacTestRun)
	Object.SetProperty(MySwitch,"EvacTestRun",EvacTestRun)
	this.SetInterfaceCaption("toggleEvacTestRun", "tooltip_button_evactestrun",button_txt,"X")
end

function toggleSortMinClicked()
	if SortMin=="YES" then SortMin="NO" else SortMin="YES" end
	button_txt="tooltip_"..string.lower(SortMin)
	Object.SetProperty(this,"SortMin",SortMin)
	this.SetInterfaceCaption("toggleSortMin", "tooltip_button_min",button_txt,"X")
end

function toggleSortMedClicked()
	if SortMed=="YES" then SortMed="NO" else SortMed="YES" end
	button_txt="tooltip_"..string.lower(SortMed)
	Object.SetProperty(this,"SortMed",SortMed)
	this.SetInterfaceCaption("toggleSortMed", "tooltip_button_med",button_txt,"X")
end

function toggleSortMaxClicked()
	if SortMax=="YES" then SortMax="NO" else SortMax="YES" end
	button_txt="tooltip_"..string.lower(SortMax)
	Object.SetProperty(this,"SortMax",SortMax)
	this.SetInterfaceCaption("toggleSortMax", "tooltip_button_max",button_txt,"X")
end

function toggleSortSuperClicked()
	if SortSuper=="YES" then SortSuper="NO" else SortSuper="YES" end
	button_txt="tooltip_"..string.lower(SortSuper)
	Object.SetProperty(this,"SortSuper",SortSuper)
	this.SetInterfaceCaption("toggleSortSuper", "tooltip_button_sup",button_txt,"X")
end

function toggleSortDeathClicked()
	if SortDeath=="YES" then SortDeath="NO" else SortDeath="YES" end
	button_txt="tooltip_"..string.lower(SortDeath)
	Object.SetProperty(this,"SortDeath",SortDeath)
	this.SetInterfaceCaption("toggleSortDeath", "tooltip_button_death",button_txt,"X")
end

function toggleObeyMinClicked()
	if ObeyMin=="YES" then ObeyMin="NO" else ObeyMin="YES" end
	button_txt="tooltip_"..string.lower(ObeyMin)
	Object.SetProperty(this,"ObeyMin",ObeyMin)
	this.SetInterfaceCaption("toggleObeyMin", "tooltip_button_min",button_txt,"X")
end

function toggleObeyMedClicked()
	if ObeyMed=="YES" then ObeyMed="NO" else ObeyMed="YES" end
	button_txt="tooltip_"..string.lower(ObeyMed)
	Object.SetProperty(this,"ObeyMed",ObeyMed)
	this.SetInterfaceCaption("toggleObeyMed", "tooltip_button_med",button_txt,"X")
end

function toggleObeyMaxClicked()
	if ObeyMax=="YES" then ObeyMax="NO" else ObeyMax="YES" end
	button_txt="tooltip_"..string.lower(ObeyMax)
	Object.SetProperty(this,"ObeyMax",ObeyMax)
	this.SetInterfaceCaption("toggleObeyMax", "tooltip_button_max",button_txt,"X")
end

function toggleObeySuperClicked()
	if ObeySuper=="YES" then ObeySuper="NO" else ObeySuper="YES" end
	button_txt="tooltip_"..string.lower(ObeySuper)
	Object.SetProperty(this,"ObeySuper",ObeySuper)
	this.SetInterfaceCaption("toggleObeySuper", "tooltip_button_sup",button_txt,"X")
end

function toggleObeyProtClicked()
	if ObeyProt=="YES" then ObeyProt="NO" else ObeyProt="YES" end
	button_txt="tooltip_"..string.lower(ObeyProt)
	Object.SetProperty(this,"ObeyProt",ObeyProt)
	this.SetInterfaceCaption("toggleObeyProt", "tooltip_button_prot",button_txt,"X")
end

function toggleObeyDeathClicked()
	if ObeyDeath=="YES" then ObeyDeath="NO" else ObeyDeath="YES" end
	button_txt="tooltip_"..string.lower(ObeyDeath)
	Object.SetProperty(this,"ObeyDeath",ObeyDeath)
	this.SetInterfaceCaption("toggleObeyDeath", "tooltip_button_death",button_txt,"X")
end

function toggleGangSorter0Clicked()
	if SortGangs0=="GangToSection" then SortGangs0="SectionToGang" else SortGangs0="GangToSection" end
	Object.SetProperty(this,"GangSorter0",SortGangs0)
	button_txt="tooltip_"..string.lower(SortGangs0)
	this.SetInterfaceCaption("toggleGangSorter0", button_txt)
end

function toggleGangSorter1Clicked()
	if SortGangs1=="GangToSection" then SortGangs1="SectionToGang" else SortGangs1="GangToSection" end
	Object.SetProperty(this,"GangSorter1",SortGangs1)
	button_txt="tooltip_"..string.lower(SortGangs1)
	this.SetInterfaceCaption("toggleGangSorter1", button_txt)
end

function toggleGangSorter2Clicked()
	if SortGangs2=="GangToSection" then SortGangs2="SectionToGang" else SortGangs2="GangToSection" end
	Object.SetProperty(this,"GangSorter2",SortGangs2)
	button_txt="tooltip_"..string.lower(SortGangs2)
	this.SetInterfaceCaption("toggleGangSorter2", button_txt)
end

function toggleSnitchIntervalClicked()
	RandomSnitchTimer=math.random(9,24)/math.pi
	Object.SetProperty(this,"RNDSnitchTimer",RandomSnitchTimer)
	timeToDoSnitchSort=RandomSnitchTimer
	this.SetInterfaceCaption("toggleSnitchInterval", "tooltip_button_nextsweep",string.sub(tostring(this.RNDSnitchTimer),0,4),"X")
end
	
function toggleObeyIntervalClicked()
	RandomObeyTimer=(math.random(15,30)+math.random(2,30))/math.pi
	Object.SetProperty(this,"RNDObeyTimer",RandomObeyTimer)
	timeToDoObey=RandomObeyTimer
	this.SetInterfaceCaption("toggleObeyInterval", "tooltip_button_nextsweep",string.sub(tostring(this.RNDObeyTimer),0,4),"X")
end
	
function toggleEvacIntervalClicked()
	RandomEvacTimer=math.random(5,12)/math.pi
	Object.SetProperty(this,"RNDEvacTimer",RandomEvacTimer)
	timeToDoEvac=RandomEvacTimer
	this.SetInterfaceCaption("toggleEvacInterval", "tooltip_button_nextsweep",string.sub(tostring(this.RNDEvacTimer),0,4),"X")
end

function toggleGang0IntervalClicked()
	RandomGang0Timer=math.random(9,24)/math.pi
	Object.SetProperty(this,"RNDGang0Timer",RandomGang0Timer)
	timeToDoGang0=RandomGang0Timer
	this.SetInterfaceCaption("toggleGang0Interval", "tooltip_button_nextsweep",string.sub(tostring(this.RNDGang0Timer),0,4),"X")
end

function toggleGang1IntervalClicked()
	RandomGang1Timer=math.random(9,24)/math.pi
	Object.SetProperty(this,"RNDGang1Timer",RandomGang1Timer)
	timeToDoGang1=RandomGang1Timer
	this.SetInterfaceCaption("toggleGang1Interval", "tooltip_button_nextsweep",string.sub(tostring(this.RNDGang1Timer),0,4),"X")
end

function toggleGang2IntervalClicked()
	RandomGang2Timer=math.random(9,24)/math.pi
	Object.SetProperty(this,"RNDGang2Timer",RandomGang2Timer)
	timeToDoGang2=RandomGang2Timer
	this.SetInterfaceCaption("toggleGang2Interval", "tooltip_button_nextsweep",string.sub(tostring(this.RNDGang2Timer),0,4),"X")
end

function toggleShowCoveredPowerAreaClicked()
	if CoveredByPower==true then
		HideCoveredArea("Power")
		CoveredByPower=false
	else
		ShowCoveredArea(this.PowerRange,"Power")
		CoveredByPower=true
	end
end

function toggleShowCoveredSnitchAreaClicked()
	if CoveredBySnitch==true then
		HideCoveredArea("Snitch")
		CoveredBySnitch=false
	else
		ShowCoveredArea(this.SnitchRange,"Snitch")
		CoveredBySnitch=true
	end
end

function toggleShowCoveredObeyAreaClicked()
	if CoveredByObey==true then
		HideCoveredArea("Obey")
		CoveredByObey=false
	else
		ShowCoveredArea(this.ObeyRange,"Obey")
		CoveredByObey=true
	end
end

function toggleShowCoveredEvacAreaClicked()
	if CoveredByEvac==true then
		HideCoveredArea("Evac")
		CoveredByEvac=false
	else
		ShowCoveredArea(this.EvacRange,"Evac")
		CoveredByEvac=true
	end
end

function toggleShowCoveredGang0AreaClicked()
	if CoveredByGang0==true then
		HideCoveredArea("Gang"..tostring(this.GangId0-2).."A")
		CoveredByGang0=false
	else
		ShowCoveredArea(this.GangRange0,"Gang"..tostring(this.GangId0-2).."A")
		CoveredByGang0=true
	end
end

function toggleShowCoveredGang1AreaClicked()
	if CoveredByGang1==true then
		HideCoveredArea("Gang"..tostring(this.GangId1-2).."B")
		CoveredByGang1=false
	else
		ShowCoveredArea(this.GangRange1,"Gang"..tostring(this.GangId1-2).."B")
		CoveredByGang1=true
	end
end

function toggleShowCoveredGang2AreaClicked()
	if CoveredByGang2==true then
		HideCoveredArea("Gang"..tostring(this.GangId2-2).."C")
		CoveredByGang2=false
	else
		ShowCoveredArea(this.GangRange2,"Gang"..tostring(this.GangId2-2).."C")
		CoveredByGang2=true
	end
end

-- Add the buttons for the utilities

function AddPowerButtons()
	Interface.AddComponent(this,this.HomeUID.."CaptionPoweroptions", "Caption", "tooltip_Poweroptions")
	if this.PowerRange==nil then
		PowerRange=5
		PoweredObjects=0
		PowerLights="NO"
		PowerPress="NO"
		PowerSaw="NO"
		PowerFridge="NO"
		PowerCooker="NO"
		PowerMetal="NO"
		PowerCCTV="NO"
		PowerDoorControl="NO"
		PowerPhoneMonitor="NO"
		Object.SetProperty(this,"PowerRange",PowerRange)
		Interface.AddComponent(this,"togglePowerRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredPowerArea", "Button", "tooltip_button_ShowHideRange",this.PowerRange,"X")
		Interface.AddComponent(this,"togglePowerRangeMinus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captionpowerconfig", "Caption", "tooltip_boothconfig")
		Object.SetProperty(this,"PowerLights",PowerLights);		button_txt="tooltip_"..string.lower(PowerLights);	Interface.AddComponent(this,"togglePowerLights", "Button", "tooltip_button_powerlights",button_txt,"X")
		Object.SetProperty(this,"PowerPress",PowerPress);		button_txt="tooltip_"..string.lower(PowerPress);	Interface.AddComponent(this,"togglePowerPress", "Button", "tooltip_button_powerpress",button_txt,"X")
		Object.SetProperty(this,"PowerSaw",PowerSaw);			button_txt="tooltip_"..string.lower(PowerSaw);		Interface.AddComponent(this,"togglePowerSaw", "Button", "tooltip_button_powersaw",button_txt,"X")
		Object.SetProperty(this,"PowerFridge",PowerFridge);		button_txt="tooltip_"..string.lower(PowerFridge);	Interface.AddComponent(this,"togglePowerFridge", "Button", "tooltip_button_powerfridge",button_txt,"X")
		Object.SetProperty(this,"PowerCooker",PowerCooker);		button_txt="tooltip_"..string.lower(PowerCooker);	Interface.AddComponent(this,"togglePowerCooker", "Button", "tooltip_button_powercooker",button_txt,"X")
		Object.SetProperty(this,"PowerMetal",PowerMetal);		button_txt="tooltip_"..string.lower(PowerMetal);	Interface.AddComponent(this,"togglePowerMetal", "Button", "tooltip_button_PowerMetal",button_txt,"X")
		Object.SetProperty(this,"PowerCCTV",PowerCCTV);			button_txt="tooltip_"..string.lower(PowerCCTV);		Interface.AddComponent(this,"togglePowerCCTV", "Button", "tooltip_button_PowerCCTV",button_txt,"X")
		Object.SetProperty(this,"PowerPhoneMonitor",PowerPhoneMonitor);		button_txt="tooltip_"..string.lower(PowerPhoneMonitor);	Interface.AddComponent(this,"togglePowerPhoneMonitor", "Button", "tooltip_button_PowerPhoneMonitor",button_txt,"X")
		Object.SetProperty(this,"PowerDoorControl",PowerDoorControl);		button_txt="tooltip_"..string.lower(PowerDoorControl);	Interface.AddComponent(this,"togglePowerDoorControl", "Button", "tooltip_button_powerDoorControl",button_txt,"X")
	else
		PowerRange=this.PowerRange
		Interface.AddComponent(this,"togglePowerRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredPowerArea", "Button", "tooltip_button_ShowHiderange",this.PowerRange,"X")
		Interface.AddComponent(this,"togglePowerRangeMinus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captionpowerconfig", "Caption", "tooltip_boothconfig")
		PowerLights=this.PowerLights;		button_txt="tooltip_"..string.lower(PowerLights);	Interface.AddComponent(this,"togglePowerLights", "Button", "tooltip_button_powerlights",button_txt,"X")
		PowerPress=this.PowerPress;			button_txt="tooltip_"..string.lower(PowerPress);	Interface.AddComponent(this,"togglePowerPress", "Button", "tooltip_button_powerpress",button_txt,"X")
		PowerSaw=this.PowerSaw;				button_txt="tooltip_"..string.lower(PowerSaw);		Interface.AddComponent(this,"togglePowerSaw", "Button", "tooltip_button_powersaw",button_txt,"X")
		PowerFridge=this.PowerFridge;		button_txt="tooltip_"..string.lower(PowerFridge);	Interface.AddComponent(this,"togglePowerFridge", "Button", "tooltip_button_powerfridge",button_txt,"X")
		PowerCooker=this.PowerCooker;		button_txt="tooltip_"..string.lower(PowerCooker);	Interface.AddComponent(this,"togglePowerCooker", "Button", "tooltip_button_powercooker",button_txt,"X")
		PowerMetal=this.PowerMetal;			button_txt="tooltip_"..string.lower(PowerMetal);	Interface.AddComponent(this,"togglePowerMetal", "Button", "tooltip_button_PowerMetal",button_txt,"X")
		PowerCCTV=this.PowerCCTV;			button_txt="tooltip_"..string.lower(PowerCCTV);		Interface.AddComponent(this,"togglePowerCCTV", "Button", "tooltip_button_PowerCCTV",button_txt,"X")
		PowerPhoneMonitor=this.PowerPhoneMonitor;		button_txt="tooltip_"..string.lower(PowerPhoneMonitor);	Interface.AddComponent(this,"togglePowerPhoneMonitor", "Button", "tooltip_button_PowerPhoneMonitor",button_txt,"X")
		PowerDoorControl=this.PowerDoorControl;			button_txt="tooltip_"..string.lower(PowerDoorControl);	Interface.AddComponent(this,"togglePowerDoorControl", "Button", "tooltip_button_powerDoorControl",button_txt,"X")
	end
	Interface.AddComponent(this,"toggleUpdateObjects", "Button", "tooltip_button_updateobjects")
end

function RemovePowerButtons()
	Interface.RemoveComponent(this,this.HomeUID.."CaptionPoweroptions", "Caption", "tooltip_Poweroptions")
	Interface.RemoveComponent(this,"togglePowerRangePlus", "Button", "tooltip_button_changerangeplus")
	Interface.RemoveComponent(this,"toggleShowCoveredPowerArea", "Button", "tooltip_button_ShowHideRange",this.PowerRange,"X")
	Interface.RemoveComponent(this,"togglePowerRangeMinus", "Button", "tooltip_button_changerangeminus")
	Interface.RemoveComponent(this,this.HomeUID.."Captionpowerconfig", "Caption", "tooltip_boothconfig")
	Interface.RemoveComponent(this,"togglePowerLights", "Button", "tooltip_button_powerlights",button_txt,"X")
	Interface.RemoveComponent(this,"togglePowerPress", "Button", "tooltip_button_powerpress",button_txt,"X")
	Interface.RemoveComponent(this,"togglePowerSaw", "Button", "tooltip_button_powersaw",button_txt,"X")
	Interface.RemoveComponent(this,"togglePowerFridge", "Button", "tooltip_button_powerfridge",button_txt,"X")
	Interface.RemoveComponent(this,"togglePowerCooker", "Button", "tooltip_button_powercooker",button_txt,"X")
	Interface.RemoveComponent(this,"togglePowerMetal", "Button", "tooltip_button_PowerMetal",button_txt,"X")
	Interface.RemoveComponent(this,"togglePowerCCTV", "Button", "tooltip_button_PowerCCTV",button_txt,"X")
	Interface.RemoveComponent(this,"togglePowerPhoneMonitor", "Button", "tooltip_button_PowerPhoneMonitor",button_txt,"X")
	Interface.RemoveComponent(this,"togglePowerDoorControl", "Button", "tooltip_button_powerDoorControl",button_txt,"X")
	Interface.RemoveComponent(this,"toggleUpdateObjects", "Button", "tooltip_button_updateobjects")
	Object.SetProperty(this,"PowerLights","");		PowerLights=nil
	Object.SetProperty(this,"PowerPress","");		PowerPress=nil
	Object.SetProperty(this,"PowerSaw","");			PowerSaw=nil
	Object.SetProperty(this,"PowerFridge","");		PowerFridge=nil
	Object.SetProperty(this,"PowerCooker","");		PowerCooker=nil
	Object.SetProperty(this,"PowerMetal","");		PowerMetal=nil
	Object.SetProperty(this,"PowerCCTV","");		PowerCCTV=nil
	Object.SetProperty(this,"PowerPhoneMonitor","");	PowerPhoneMonitor=nil
	Object.SetProperty(this,"PowerDoorControl","");	PowerDoorControl=nil
	Object.SetProperty(this,"PowerRange","");		PowerRange=nil
	ReadyToPower=false
end

function AddSnitchButtons()
	Interface.AddComponent(this,this.HomeUID.."Captionsnitchoptions", "Caption", "tooltip_snitchoptions")
	if this.SnitchRange==nil then
		SnitchRange=5
		SortMin="YES"
		SortMed="YES"
		SortMax="YES"
		SortSuper="YES"
		SortDeath="NO"
		Object.SetProperty(this,"SnitchRange",SnitchRange)
		Interface.AddComponent(this,"toggleSnitchRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredSnitchArea", "Button", "tooltip_button_ShowHideRange",this.SnitchRange,"X")
		Interface.AddComponent(this,"toggleSnitchRangeMinus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captionsnitchconfig", "Caption", "tooltip_boothconfig")
		Object.SetProperty(this,"SortMin",SortMin);		button_txt="tooltip_"..string.lower(SortMin);	Interface.AddComponent(this,"toggleSortMin", "Button", "tooltip_button_min",button_txt,"X")
		Object.SetProperty(this,"SortMed",SortMed);		button_txt="tooltip_"..string.lower(SortMed);	Interface.AddComponent(this,"toggleSortMed", "Button", "tooltip_button_med",button_txt,"X")
		Object.SetProperty(this,"SortMax",SortMax);		button_txt="tooltip_"..string.lower(SortMax);	Interface.AddComponent(this,"toggleSortMax", "Button", "tooltip_button_max",button_txt,"X")
		Object.SetProperty(this,"SortSuper",SortSuper);	button_txt="tooltip_"..string.lower(SortSuper);	Interface.AddComponent(this,"toggleSortSuper", "Button", "tooltip_button_sup",button_txt,"X")
		Object.SetProperty(this,"SortDeath",SortDeath);	button_txt="tooltip_"..string.lower(SortDeath);	Interface.AddComponent(this,"toggleSortDeath", "Button", "tooltip_button_death",button_txt,"X")
	else
		SnitchRange=this.SnitchRange
		Interface.AddComponent(this,"toggleSnitchRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredSnitchArea", "Button", "tooltip_button_ShowHideRange",this.SnitchRange,"X")
		Interface.AddComponent(this,"toggleSnitchRangeMinus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captionsnitchconfig", "Caption", "tooltip_boothconfig")
		SortMin=this.SortMin;		button_txt="tooltip_"..string.lower(SortMin);	Interface.AddComponent(this,"toggleSortMin", "Button", "tooltip_button_min",button_txt,"X")
		SortMed=this.SortMed;		button_txt="tooltip_"..string.lower(SortMed);	Interface.AddComponent(this,"toggleSortMed", "Button", "tooltip_button_med",button_txt,"X")
		SortMax=this.SortMax;		button_txt="tooltip_"..string.lower(SortMax);	Interface.AddComponent(this,"toggleSortMax", "Button", "tooltip_button_max",button_txt,"X")
		SortSuper=this.SortSuper;	button_txt="tooltip_"..string.lower(SortSuper);	Interface.AddComponent(this,"toggleSortSuper", "Button", "tooltip_button_sup",button_txt,"X")
		SortDeath=this.SortDeath;	button_txt="tooltip_"..string.lower(SortDeath);	Interface.AddComponent(this,"toggleSortDeath", "Button", "tooltip_button_death",button_txt,"X")
	end
	Interface.AddComponent(this,"toggleSnitchInterval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDSnitchTimer),0,4),"X")
end

function RemoveSnitchButtons()
	Interface.RemoveComponent(this,this.HomeUID.."Captionsnitchoptions", "Caption", "tooltip_snitchoptions")
	Interface.RemoveComponent(this,"toggleSnitchRangePlus", "Button", "tooltip_button_changerangeplus")
	Interface.RemoveComponent(this,"toggleShowCoveredSnitchArea", "Button", "tooltip_button_ShowHideRange",this.SnitchRange,"X")
	Interface.RemoveComponent(this,"toggleSnitchRangeMinus", "Button", "tooltip_button_changerangeminus")
	Interface.RemoveComponent(this,this.HomeUID.."Captionsnitchconfig", "Caption", "tooltip_boothconfig")
	Interface.RemoveComponent(this,"toggleSortMin", "Button", "tooltip_button_min",button_txt,"X")
	Interface.RemoveComponent(this,"toggleSortMed", "Button", "tooltip_button_med",button_txt,"X")
	Interface.RemoveComponent(this,"toggleSortMax", "Button", "tooltip_button_max",button_txt,"X")
	Interface.RemoveComponent(this,"toggleSortSuper", "Button", "tooltip_button_sup",button_txt,"X")
	Interface.RemoveComponent(this,"toggleSortDeath", "Button", "tooltip_button_death",button_txt,"X")
	Interface.RemoveComponent(this,"toggleSnitchInterval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDSnitchTimer),0,4),"X")
	Object.SetProperty(this,"SortMin","");		SortMin=nil
	Object.SetProperty(this,"SortMed","");		SortMed=nil
	Object.SetProperty(this,"SortMax","");		SortMax=nil
	Object.SetProperty(this,"SortSuper","");	SortSuper=nil
	Object.SetProperty(this,"SortDeath","");	SortDeath=nil
	Object.SetProperty(this,"SnitchRange","");	SnitchRange=nil
	Object.SetProperty(this,"RNDSnitchTimer","");	ReadyToSnitch=false
end

function AddObeyButtons()
	Interface.AddComponent(this,this.HomeUID.."Captionobeyoptions", "Caption", "tooltip_obeyoptions")
	if this.ObeyRange==nil then
		ObeyRange=5
		ObeyMin="NO"
		ObeyMed="NO"
		ObeyMax="YES"
		ObeySuper="YES"
		ObeyProt="YES"
		ObeyDeath="YES"
		Object.SetProperty(this,"ObeyRange",ObeyRange)
		Interface.AddComponent(this,"toggleObeyRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredObeyArea", "Button", "tooltip_button_ShowHideRange",this.ObeyRange,"X")
		Interface.AddComponent(this,"toggleObeyRangeMinus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captionobeyconfig", "Caption", "tooltip_boothconfig")
		Object.SetProperty(this,"ObeyMin",ObeyMin);		button_txt="tooltip_"..string.lower(ObeyMin);	Interface.AddComponent(this,"toggleObeyMin", "Button", "tooltip_button_min",button_txt,"X")
		Object.SetProperty(this,"ObeyMed",ObeyMed);		button_txt="tooltip_"..string.lower(ObeyMed);	Interface.AddComponent(this,"toggleObeyMed", "Button", "tooltip_button_med",button_txt,"X")
		Object.SetProperty(this,"ObeyMax",ObeyMax);		button_txt="tooltip_"..string.lower(ObeyMax);	Interface.AddComponent(this,"toggleObeyMax", "Button", "tooltip_button_max",button_txt,"X")
		Object.SetProperty(this,"ObeySuper",ObeySuper);	button_txt="tooltip_"..string.lower(ObeySuper);	Interface.AddComponent(this,"toggleObeySuper", "Button", "tooltip_button_sup",button_txt,"X")
		Object.SetProperty(this,"ObeyProt",ObeyProt);	button_txt="tooltip_"..string.lower(ObeyProt);	Interface.AddComponent(this,"toggleObeyProt", "Button", "tooltip_button_prot",button_txt,"X")
		Object.SetProperty(this,"ObeyDeath",ObeyDeath);	button_txt="tooltip_"..string.lower(ObeyDeath);	Interface.AddComponent(this,"toggleObeyDeath", "Button", "tooltip_button_death",button_txt,"X")
	else
		ObeyRange=this.ObeyRange
		Interface.AddComponent(this,"toggleObeyRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredObeyArea", "Button", "tooltip_button_ShowHideRange",this.ObeyRange,"X")
		Interface.AddComponent(this,"toggleObeyRangeMinus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captionobeyconfig", "Caption", "tooltip_boothconfig")
		ObeyMin=this.ObeyMin;		button_txt="tooltip_"..string.lower(ObeyMin);	Interface.AddComponent(this,"toggleObeyMin", "Button", "tooltip_button_min",button_txt,"X")
		ObeyMed=this.ObeyMed;		button_txt="tooltip_"..string.lower(ObeyMed);	Interface.AddComponent(this,"toggleObeyMed", "Button", "tooltip_button_med",button_txt,"X")
		ObeyMax=this.ObeyMax;		button_txt="tooltip_"..string.lower(ObeyMax);	Interface.AddComponent(this,"toggleObeyMax", "Button", "tooltip_button_max",button_txt,"X")
		ObeySuper=this.ObeySuper;	button_txt="tooltip_"..string.lower(ObeySuper);	Interface.AddComponent(this,"toggleObeySuper", "Button", "tooltip_button_sup",button_txt,"X")
		ObeyProt=this.ObeyProt;		button_txt="tooltip_"..string.lower(ObeyProt);	Interface.AddComponent(this,"toggleObeyProt", "Button", "tooltip_button_prot",button_txt,"X")
		ObeyDeath=this.ObeyDeath;	button_txt="tooltip_"..string.lower(ObeyDeath);	Interface.AddComponent(this,"toggleObeyDeath", "Button", "tooltip_button_death",button_txt,"X")
	end
	Interface.AddComponent(this,"toggleObeyInterval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDObeyTimer),0,4),"X")
end

function RemoveObeyButtons()
	Interface.RemoveComponent(this,this.HomeUID.."Captionobeyoptions", "Caption", "tooltip_obeyoptions")
	Interface.RemoveComponent(this,"toggleObeyRangePlus", "Button", "tooltip_button_changerangeplus")
	Interface.RemoveComponent(this,"toggleShowCoveredObeyArea", "Button", "tooltip_button_ShowHideRange",this.ObeyRange,"X")
	Interface.RemoveComponent(this,"toggleObeyRangeMinus", "Button", "tooltip_button_changerangeminus")
	Interface.RemoveComponent(this,this.HomeUID.."Captionobeyconfig", "Caption", "tooltip_boothconfig")
	Interface.RemoveComponent(this,"toggleObeyMin", "Button", "tooltip_button_min",button_txt,"X")
	Interface.RemoveComponent(this,"toggleObeyMed", "Button", "tooltip_button_med",button_txt,"X")
	Interface.RemoveComponent(this,"toggleObeyMax", "Button", "tooltip_button_max",button_txt,"X")
	Interface.RemoveComponent(this,"toggleObeySuper", "Button", "tooltip_button_sup",button_txt,"X")
	Interface.RemoveComponent(this,"toggleObeyProt", "Button", "tooltip_button_prot",button_txt,"X")
	Interface.RemoveComponent(this,"toggleObeyDeath", "Button", "tooltip_button_death",button_txt,"X")
	Interface.RemoveComponent(this,"toggleObeyInterval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDObeyTimer),0,4),"X")
	Object.SetProperty(this,"ObeyMin","");		ObeyMin=nil
	Object.SetProperty(this,"ObeyMed","");		ObeyMed=nil
	Object.SetProperty(this,"ObeyMax","");		ObeyMax=nil
	Object.SetProperty(this,"ObeySuper","");	ObeySuper=nil
	Object.SetProperty(this,"ObeyProt","");		ObeyProt=nil
	Object.SetProperty(this,"ObeyDeath","");	ObeyDeath=nil
	Object.SetProperty(this,"ObeyRange","");	ObeyRange=nil
	Object.SetProperty(this,"RNDObeyTimer","");		ReadyToObey=false
end

function AddEvacButtons()
	evactypes = { [1] = ALL, [2] = Staff, [3] = Guards, [4] = Prisoners, [5] = Emergency, [6] = Administration, [7] = Visitors }
	GROUPS = {
	{"Sniper", "Workman", "Guard", "RiotGuard", "ArmedGuard", "Doctor", "Paramedic", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Teacher", "Soldier", "Warden", "Chief", "Foreman", "Psychologist", "Accountant", "Lawyer", "AppealsLawyer", "ParoleLawyer", "ParoleOfficer", "AppealsMagistrate", "SpiritualLeader", "Avatar", "Actor", "Prisoner", "Visitor"},
	{"Sniper", "Workman", "Guard", "RiotGuard", "ArmedGuard", "Doctor", "Paramedic", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Teacher", "Soldier", "Warden", "Chief", "Foreman", "Psychologist", "Accountant", "Lawyer", "AppealsLawyer", "ParoleLawyer", "ParoleOfficer", "AppealsMagistrate"},
	{"Prisoner", "Avator", "Actor"},
	{"Sniper", "Guard", "RiotGuard", "ArmedGuard", "Soldier"},
	{"Paramedic", "Fireman", "Soldier", "RiotGuard"},
	{"Warden", "Chief", "Foreman", "Psychologist", "Accountant", "Lawyer", "AppealsLawyer", "ParoleLawyer", "ParoleOfficer", "AppealsMagistrate"},
	{"Visitor"}}
	Animation = { [1] = 15, [2] = 16 }
	Frame = 1
	Interface.AddComponent(this,this.HomeUID.."Captionevacoptions", "Caption", "tooltip_evacoptions")
	if this.EvacRange==nil then
		EvacRange=5
		Object.SetProperty(this,"EvacRange",EvacRange)
		Interface.AddComponent(this,"toggleEvacRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredEvacArea", "Button", "tooltip_button_ShowHideRange",this.EvacRange,"X")
		Interface.AddComponent(this,"toggleEvacRangeMinus", "Button", "tooltip_button_changerangeminus")
	else
		EvacRange=this.EvacRange
		Interface.AddComponent(this,"toggleEvacRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredEvacArea", "Button", "tooltip_button_ShowHideRange",this.EvacRange,"X")
		Interface.AddComponent(this,"toggleEvacRangeMinus", "Button", "tooltip_button_changerangeminus")
	end
	Interface.AddComponent(this,this.HomeUID.."Captionevacconfig", "Caption", "tooltip_boothconfig")
	Interface.AddComponent(this,"toggleEvacInterval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDEvacTimer),0,4),"X")
	if MySwitch.EvacTestRun==nil then
		EvacTestRun="YES"
		Object.SetProperty(MySwitch,"EvacTestRun",EvacTestRun)
	else
		EvacTestRun=MySwitch.EvacTestRun
	end
	button_txt="tooltip_"..string.lower(EvacTestRun);	Interface.AddComponent(this,"toggleEvacTestRun", "Button", "tooltip_button_evactestrun",button_txt,"X")
end

function RemoveEvacButtons()
	Interface.RemoveComponent(this,this.HomeUID.."Captionevacoptions", "Caption", "tooltip_evacoptions")
	Interface.RemoveComponent(this,"toggleEvacRangePlus", "Button", "tooltip_button_changerangeplus")
	Interface.RemoveComponent(this,"toggleShowCoveredEvacArea", "Button", "tooltip_button_ShowHideRange",this.EvacRange,"X")
	Interface.RemoveComponent(this,"toggleEvacRangeMinus", "Button", "tooltip_button_changerangeminus")
	Interface.RemoveComponent(this,this.HomeUID.."Captionevacconfig", "Caption", "tooltip_boothconfig")
	Interface.RemoveComponent(this,"toggleEvacInterval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDEvacTimer),0,4),"X")
	Interface.RemoveComponent(this,"toggleEvacTestRun", "Button", "tooltip_button_evactestrun",button_txt,"X")
	Object.SetProperty(this,"EvacRange","");		EvacRange=nil
	Object.SetProperty(MySwitch,"EvacTestRun","");	Animation=nil
	Object.SetProperty(this,"RNDEvacTimer","");		ReadyToEvac=false
	GROUPS=nil;	evactypes=nil;	EvacTestRun=nil
end

function AddGang0Buttons()
	SortGangs0="GangToSection"
	mySectionToGangList0={}
	mySectionToGangListNumber0=0
	SalvagedPrisoners0=0
	Interface.AddComponent(this,this.HomeUID.."Captiongangoptions0", "Caption", "tooltip_gangoptions0")
	if this.GangRange0==nil then
		GangRange0=5
		Object.SetProperty(this,"GangRange0",GangRange0)
		Interface.AddComponent(this,"toggleGangRange0Plus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredGang0Area", "Button", "tooltip_button_ShowHideRange",this.GangRange0,"X")
		Interface.AddComponent(this,"toggleGangRange0Minus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captiongangconfig0", "Caption", "tooltip_boothconfig")
		Object.SetProperty(this,"GangSorter0",SortGangs0)
		button_txt="tooltip_"..string.lower(SortGangs0)
		Interface.AddComponent(this,"toggleGangSorter0", "Button", button_txt)
	else
		GangRange0=this.GangRange0
		Interface.AddComponent(this,"toggleGangRange0Plus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredGang0Area", "Button", "tooltip_button_ShowHideRange",this.GangRange0,"X")
		Interface.AddComponent(this,"toggleGangRange0Minus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captiongangconfig0", "Caption", "tooltip_boothconfig")
		if this.GangSorter0==nil then
			Object.SetProperty(this,"GangSorter0",SortGangs0)
			button_txt="tooltip_"..string.lower(SortGangs0)
			Interface.AddComponent(this,"toggleGangSorter0", "Button", button_txt)
		else
			SortGangs0=this.GangSorter0
			button_txt="tooltip_"..string.lower(SortGangs0)
			Interface.AddComponent(this,"toggleGangSorter0", "Button", button_txt)
		end
	end
	Interface.AddComponent(this,"toggleGang0Interval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDGang0Timer),0,4),"X")
end

function RemoveGang0Buttons()
	Interface.RemoveComponent(this,this.HomeUID.."Captiongangoptions0", "Caption", "tooltip_gangoptions0")
	Interface.RemoveComponent(this,"toggleGangRange0Plus", "Button", "tooltip_button_changerangeplus")
	Interface.RemoveComponent(this,"toggleShowCoveredGang0Area", "Button", "tooltip_button_ShowHideRange",this.GangRange0,"X")
	Interface.RemoveComponent(this,"toggleGangRange0Minus", "Button", "tooltip_button_changerangeminus")
	Interface.RemoveComponent(this,this.HomeUID.."Captiongangconfig0", "Caption", "tooltip_boothconfig")
	Interface.RemoveComponent(this,"toggleGangSorter0", "Button", button_txt)
	Interface.RemoveComponent(this,"toggleGang0Interval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDGang0Timer),0,4),"X")
	Object.SetProperty(this,"GangRange0","");					GangRange0=nil
	Object.SetProperty(this,"GangSorter0","GangToSection");		SortGangs0=nil
	Object.SetProperty(this,"RNDGang0Timer","");	ReadyToGangSort0=false
	mySectionToGangList0=nil;	mySectionToGangListNumber0=nil;	SalvagedPrisoners0=nil
	dir0txt=nil
end

function AddGang1Buttons()
	SortGangs1="GangToSection"
	mySectionToGangList1={}
	mySectionToGangListNumber1=0
	SalvagedPrisoners1=0
	Interface.AddComponent(this,this.HomeUID.."Captiongangoptions1", "Caption", "tooltip_gangoptions1")
	if this.GangRange1==nil then
		GangRange1=5
		Object.SetProperty(this,"GangRange1",GangRange1)
		Interface.AddComponent(this,"toggleGangRange1Plus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredGang1Area", "Button", "tooltip_button_ShowHideRange",this.GangRange1,"X")
		Interface.AddComponent(this,"toggleGangRange1Minus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captiongangconfig1", "Caption", "tooltip_boothconfig")
		Object.SetProperty(this,"GangSorter1",SortGangs1)
		button_txt="tooltip_"..string.lower(SortGangs1)
		Interface.AddComponent(this,"toggleGangSorter1", "Button", button_txt)
	else
		GangRange1=this.GangRange1
		Interface.AddComponent(this,"toggleGangRange1Plus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredGang1Area", "Button", "tooltip_button_ShowHideRange",this.GangRange1,"X")
		Interface.AddComponent(this,"toggleGangRange1Minus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captiongangconfig1", "Caption", "tooltip_boothconfig")
		if this.GangSorter1==nil then
			Object.SetProperty(this,"GangSorter1",SortGangs1)
			button_txt="tooltip_"..string.lower(SortGangs1)
			Interface.AddComponent(this,"toggleGangSorter1", "Button", button_txt)
		else
			SortGangs1=this.GangSorter1
			button_txt="tooltip_"..string.lower(SortGangs1)
			Interface.AddComponent(this,"toggleGangSorter1", "Button", button_txt)
		end
	end
	Interface.AddComponent(this,"toggleGang1Interval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDGang1Timer),0,4),"X")
end

function RemoveGang1Buttons()
	Interface.RemoveComponent(this,this.HomeUID.."Captiongangoptions1", "Caption", "tooltip_gangoptions1")
	Interface.RemoveComponent(this,"toggleGangRange1Plus", "Button", "tooltip_button_changerangeplus")
	Interface.RemoveComponent(this,"toggleShowCoveredGang1Area", "Button", "tooltip_button_ShowHideRange",this.GangRange1,"X")
	Interface.RemoveComponent(this,"toggleGangRange1Minus", "Button", "tooltip_button_changerangeminus")
	Interface.RemoveComponent(this,this.HomeUID.."Captiongangconfig1", "Caption", "tooltip_boothconfig")
	Interface.RemoveComponent(this,"toggleGangSorter1", "Button", button_txt)
	Interface.RemoveComponent(this,"toggleGang1Interval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDGang1Timer),0,4),"X")
	Object.SetProperty(this,"GangRange1","");					GangRange1=nil
	Object.SetProperty(this,"GangSorter1","GangToSection");		SortGangs1=nil
	Object.SetProperty(this,"RNDGang1Timer","");	ReadyToGangSort1=false
	mySectionToGangList1=nil;	mySectionToGangListNumber1=nil;	SalvagedPrisoners1=nil
	dir1txt=nil
end

function AddGang2Buttons()
	SortGangs2="GangToSection"
	mySectionToGangList2={}
	mySectionToGangListNumber2=0
	SalvagedPrisoners2=0
	Interface.AddComponent( this,"Captiongangoptions2", "Caption", "tooltip_gangoptions2")
	if this.GangRange2==nil then
		GangRange2=5
		Object.SetProperty(this,"GangRange2",GangRange2)
		Interface.AddComponent(this,"toggleGangRange2Plus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredGang2Area", "Button", "tooltip_button_ShowHideRange",this.GangRange2,"X")
		Interface.AddComponent(this,"toggleGangRange2Minus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captiongangconfig2", "Caption", "tooltip_boothconfig")
		Object.SetProperty(this,"GangSorter2",SortGangs2)
		button_txt="tooltip_"..string.lower(SortGangs2)
		Interface.AddComponent(this,"toggleGangSorter2", "Button", button_txt)
	else
		GangRange2=this.GangRange2
		Interface.AddComponent(this,"toggleGangRange2Plus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredGang2Area", "Button", "tooltip_button_ShowHideRange",this.GangRange2,"X")
		Interface.AddComponent(this,"toggleGangRange2Minus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.HomeUID.."Captiongangconfig2", "Caption", "tooltip_boothconfig")
		if this.GangSorter2==nil then
			Object.SetProperty(this,"GangSorter2",SortGangs2)
			button_txt="tooltip_"..string.lower(SortGangs2)
			Interface.AddComponent(this,"toggleGangSorter2", "Button", button_txt)
		else
			SortGangs2=this.GangSorter2
			button_txt="tooltip_"..string.lower(SortGangs2)
			Interface.AddComponent(this,"toggleGangSorter2", "Button", button_txt)
		end
	end
	Interface.AddComponent(this,"toggleGang2Interval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDGang2Timer),0,4),"X")
end

function RemoveGang2Buttons()
	Interface.RemoveComponent(this,this.HomeUID.."Captiongangoptions2", "Caption", "tooltip_gangoptions2")
	Interface.RemoveComponent(this,"toggleGangRange2Plus", "Button", "tooltip_button_changerangeplus")
	Interface.RemoveComponent(this,"toggleShowCoveredGang2Area", "Button", "tooltip_button_ShowHideRange",this.GangRange2,"X")
	Interface.RemoveComponent(this,"toggleGangRange2Minus", "Button", "tooltip_button_changerangeminus")
	Interface.RemoveComponent(this,this.HomeUID.."Captiongangconfig2", "Caption", "tooltip_boothconfig")
	Interface.RemoveComponent(this,"toggleGangSorter2", "Button", button_txt)
	Interface.RemoveComponent(this,"toggleGang2Interval", "Button", "tooltip_button_nextsweep",string.sub(tostring(this.RNDGang2Timer),0,4),"X")
	Object.SetProperty(this,"GangRange2","");					GangRange2=nil
	Object.SetProperty(this,"GangSorter2","GangToSection");		SortGangs2=nil
	Object.SetProperty(this,"RNDGang2Timer","");	ReadyToGangSort2=false
	mySectionToGangList2=nil;	mySectionToGangListNumber2=nil;	SalvagedPrisoners2=nil
	dir2txt=nil
end

function toggleNothingClicked()
	--shit happens
end

--function getPoints()
--	local POINTS = {1,2,3,4,5,6,7}
--	answer = {}
--	for _, i in pairs(POINTS) do
--		for k,v in pairs(this.GetNearbyObjects("Evacuate"..tostring(i), 1000)) do answer[k] = v end
--	end
--	return answer
--end

-- END FUNCTIONS FOR UTILITYPANEL--


-- FUNCTIONS FOR UTILITY BOOTH--

function deleteMyBoothClicked()
	DeleteBooth()
end

function resetMyBoothClicked()  -- in case the booth is glitching and didn't find it's proper panels, the reset button will clear its values so it will start to scan for panels again.
	--Game.DebugOut("==Resetting booth==")
	Object.SetProperty(this,"Tooltip","tooltip_resetting")
	Object.SetProperty(MySwitch,"Switch",false)
	Object.SetProperty(MySwitch,"Tooltip","")
	SwitchIsOn = false
	Object.Sound("UtilityBooth","ResetBooth")
	--Interface.RemoveComponent( this,"resetMyBooth", "Button", "tooltip_button_resetbooth")
	UtilityPanelLoaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	PowerPanel1Loaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	SnitchPanel1Loaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	ObeyPanel1Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	GangPanel1Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	EvacPanel1Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	OtherPanel1Loaded  = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	PagerPanelLoaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	PowerPanel2Loaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	SnitchPanel2Loaded = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	ObeyPanel2Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	GangPanel2Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	EvacPanel2Loaded   = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	OtherPanel2Loaded  = { [0] = false, [1] = false, [2] = false, [3] = false, [4] = false, [5] = false }
	newTooltip = { [0] = "", [1] = "", [2] = "", [3] = "", [4] = "", [5] = "", [6] = "", [7] = "", [8] = "", [9] = "", [10] = "", [11] = "", [12] = "" }
	newSwitchTooltip = { [0] = "", [1] = "", [2] = "", [3] = "", [4] = "", [5] = "", [6] = "", [7] = "", [8] = "" }
	priorSlotI = { [0] = 0, [1] = 0, [2] = 0, [3] = 0, [4] = 0, [5] = 0 }
	priorSlotU = { [0] = 0, [1] = 0, [2] = 0, [3] = 0, [4] = 0, [5] = 0 }
	if this.PowerRange~=nil then
		RemovePowerButtons()
	end
	if this.SnitchRange~=nil then
		RemoveSnitchButtons()
	end
	if this.ObeyRange~=nil then
		RemoveObeyButtons()
	end
	if this.GangRange0~=nil then
		RemoveGang0Buttons()
	end
	if this.GangRange1~=nil then
		RemoveGang1Buttons()
	end
	if this.GangRange2~=nil then
		RemoveGang2Buttons()
	end
	if this.EvacRange~=nil then
		RemoveEvacButtons()
	end
	button_txt=nil
	MyUtilityPanel = {}
	MyPagerPanel = {}
end

function GetObjectsInSquare(theObject,theRange) -- returns targetobjects in a square around the object
	GetRangeXminYmax(theRange)
	local ListOfObjects = this.GetNearbyObjects(theObject,theRange*1.2)
	for thatObject, distance in pairs(ListOfObjects) do
		if (thatObject.Pos.x>=Xmin and thatObject.Pos.x<=Xmax) and (thatObject.Pos.y>=Ymin and thatObject.Pos.y<=Ymax) then
		-- it's ok, put other stuff here if you need
		else
			ListOfObjects[thatObject]=nil -- remove the out of bounds object from the list
		end
	end
	return ListOfObjects
end	

function GetRangeXminYmax(RangeToGet)
	Xmin=math.ceil(this.Pos.x-RangeToGet/2)
	Xmax=math.ceil(this.Pos.x+RangeToGet/2)
	Ymin=math.ceil(this.Pos.y-RangeToGet/2)
	Ymax=math.ceil(this.Pos.y+RangeToGet/2)
end	

function HideCoveredArea(theCoverType)
	for n,v in pairs(CoveredArea[theCoverType]) do
		CoveredArea[theCoverType][n].Delete()
	end
	CoveredArea[theCoverType] = nil
end

function ShowCoveredArea(theRange,theCoverType)
	GetRangeXminYmax(theRange)
	local n=0
	CoveredArea[theCoverType] = {}
	for i=Ymin,Ymax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmin,i)
		Object.SetProperty(CoveredArea[theCoverType][n],"HomeUID",this.HomeUID)
		Object.SetProperty(CoveredArea[theCoverType][n],"CoverType",theCoverType)
		if theCoverType=="Evac" then Object.SetProperty(CoveredArea[theCoverType][n],"SubType",this.EvacType) end
		CoveredArea[theCoverType][n].Tooltip={"tooltip_coveredarea",this.HomeUID,"X"}
		n=n+1
	end
	for i=Xmin,Xmax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymin)
		Object.SetProperty(CoveredArea[theCoverType][n],"HomeUID",this.HomeUID)
		Object.SetProperty(CoveredArea[theCoverType][n],"CoverType",theCoverType)
		if theCoverType=="Evac" then Object.SetProperty(CoveredArea[theCoverType][n],"SubType",this.EvacType) end
		CoveredArea[theCoverType][n].Tooltip={"tooltip_coveredarea",this.HomeUID,"X"}
		n=n+1
	end
	for i=Ymin,Ymax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmax,i)
		Object.SetProperty(CoveredArea[theCoverType][n],"HomeUID",this.HomeUID)
		Object.SetProperty(CoveredArea[theCoverType][n],"CoverType",theCoverType)
		if theCoverType=="Evac" then Object.SetProperty(CoveredArea[theCoverType][n],"SubType",this.EvacType) end
		CoveredArea[theCoverType][n].Tooltip={"tooltip_coveredarea",this.HomeUID,"X"}
		n=n+1
	end
	for i=Xmin,Xmax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymax)
		Object.SetProperty(CoveredArea[theCoverType][n],"HomeUID",this.HomeUID)
		Object.SetProperty(CoveredArea[theCoverType][n],"CoverType",theCoverType)
		if theCoverType=="Evac" then Object.SetProperty(CoveredArea[theCoverType][n],"SubType",this.EvacType) end
		CoveredArea[theCoverType][n].Tooltip={"tooltip_coveredarea",this.HomeUID,"X"}
		n=n+1
	end
end

-- Slotnumbers on utilitybooth:
--    ----    ----    ----
--   |0  3|  |1  4|  |2  5|
--    ----    ----    ---- 
--    small   medium  large booth

function FindMyPanels()
	--Game.DebugOut("==FindMyPanels STARTING==")
	local i=0
	for i=0,MySlotSize do -- max slotnumber where a utility panel can be loaded, this number varies since it can be loaded in 3 types of booths and is defined upon spawning of a booth.
		local DisplayNumber=i+1
		if currentSlotI[i] > 0 then	-- something must be loaded here, let's find out what
			if UtilityPanelLoaded[i]==false and OtherPanel1Loaded[i]==false then -- if no currently intalled panels are known for this certain display then check for a utilitypanel
				--Game.DebugOut("Checking for utilitypanels... i="..i.."")
				MyPanels = this.GetNearbyObjects('UtilityPanel',2)
				for thatPanel, distance in pairs (MyPanels) do
					if (thatPanel.CarrierId.i==this.Id.i and thatPanel.CarrierId.u==this.Id.u) and (thatPanel.Id.i==currentSlotI[i] and thatPanel.Id.u==currentSlotU[i]) then
						Object.SetProperty(thatPanel,"HomeUID",this.HomeUID)
						MyUtilityPanel[i]=thatPanel -- import my new utilitypanel
						UtilityPanelLoaded[i] = true
						--Game.DebugOut("Utility panel i="..i.." loaded")
						if MyUtilityPanel[i].PanelType=="Power (L)" then
							PowerPanel1Loaded[i]=true
							powerOffPosX=MyUtilityPanel[i].Pos.x
							powerOffPosY=MyUtilityPanel[i].Pos.y
							--Game.DebugOut("Power (L) i="..i.." loaded")
						elseif MyUtilityPanel[i].PanelType=="Snitch Sorter (L)" then
							SnitchPanel1Loaded[i]=true
							--Game.DebugOut("Snitch (L) i="..i.." loaded")
						elseif MyUtilityPanel[i].PanelType=="Obey (L)" then
							ObeyPanel1Loaded[i]=true
							--Game.DebugOut("Obey (L) i="..i.." loaded")
						elseif MyUtilityPanel[i].PanelType=="Gang (R)" then
							GangPanel1Loaded[i]=true
							--Game.DebugOut("Gang (R) i="..i.." loaded")
						elseif MyUtilityPanel[i].PanelType=="Gang (G)" then
							GangPanel1Loaded[i]=true
							--Game.DebugOut("Gang (G) i="..i.." loaded")
						elseif MyUtilityPanel[i].PanelType=="Gang (B)" then
							GangPanel1Loaded[i]=true
							--Game.DebugOut("Gang (B) i="..i.." loaded")
						elseif MyUtilityPanel[i].PanelType=="Evac (L)" then
							EvacPanel1Loaded[i]=true
							--Game.DebugOut("Evac (L) i="..i.." loaded")
						end
					end
				end
				MyPanels=nil
				if UtilityPanelLoaded[i]==false and OtherPanel1Loaded[i]==false then -- the loaded panel is not a UtilityPanel, so it must be an eyecandy panel
					--Game.DebugOut("Checking for displaypanels(L)... i="..i.."")
					MyPanels = this.GetNearbyObjects('DisplayPanelLeft',2)
					for thatPanel, distance in pairs (MyPanels) do
						if (thatPanel.CarrierId.i==this.Id.i and thatPanel.CarrierId.u==this.Id.u) and (thatPanel.Id.i==currentSlotI[i] and thatPanel.Id.u==currentSlotU[i]) then
							Object.SetProperty(thatPanel,"HomeUID",this.HomeUID)
							OtherPanel1Loaded[i]=true -- instruct the UpdateMyPanels() function to do nothing since there is no UtilityPanel loaded
							newTooltip[i] = "\nDisplay "..DisplayNumber..": Display (L)"
							--Game.DebugOut("Displaypanel (L) i="..i.." loaded")
						end
					end
					MyPanels=nil
				else
					if PowerPanel1Loaded[i]==true then
						newTooltip[i] = "\nDisplay "..DisplayNumber..": Power (L)"
					elseif SnitchPanel1Loaded[i]==true then
						newTooltip[i] = "\nDisplay "..DisplayNumber..": Snitch (L)"
					elseif ObeyPanel1Loaded[i]==true then
						newTooltip[i] = "\nDisplay "..DisplayNumber..": Obey (L)"
					elseif GangPanel1Loaded[i]==true then
						newTooltip[i] = "\nDisplay "..DisplayNumber..": Gang (L)"
					elseif EvacPanel1Loaded[i]==true then
						newTooltip[i] = "\nDisplay "..DisplayNumber..": Evac"
					else
						newTooltip[i] = "\nDisplay "..DisplayNumber..": "..MyUtilityPanel[i].PanelType..""
					end
				end
				if UtilityPanelLoaded[i]==false and OtherPanel1Loaded[i]==false then -- the loaded thing is probably a box with a panel inside... :s Getting rid of it.
					--Game.DebugOut("Checking for a box... i="..i.."")
					MyPanels = this.GetNearbyObjects('Box',2)
					for thatPanel, distance in pairs (MyPanels) do
						if (thatPanel.CarrierId.i==this.Id.i and thatPanel.CarrierId.u==this.Id.u) and (thatPanel.Id.i==currentSlotI[i] and thatPanel.Id.u==currentSlotU[i]) then
							thatPanel.Delete()
							currentSlotI[i]=nil
							currentSlotU[i]=nil
							newTooltip[i] = "\nDisplay "..DisplayNumber..": (empty)"
						end
					end
					MyPanels=nil
				end
			else -- else we already should know what's inside, so we don't need to do any other checks
				--Game.DebugOut("Did nothing B i="..i.."")
			end
		else -- reset this panels booleans to false since there is A) no panel installed yet, or B) a panel has been removed, so we need to search for a new panel on next update()
			newTooltip[i] = "\nDisplay "..DisplayNumber..": (empty)"
			newSwitchTooltip[i] = ""
			newSwitchTooltip[i+3] = ""
			newSwitchTooltip[8] = ""
			UtilityPanelLoaded[i] = false
			if PowerPanel1Loaded[i]==true then PowerPanel1Loaded[i] = false;	RemovePowerButtons();		if PowerPanel2Loaded[i]==true then newTooltip[i+3] = "- Power (R)";	end end
			if SnitchPanel1Loaded[i]==true then SnitchPanel1Loaded[i] = false;	RemoveSnitchButtons();		if SnitchPanel2Loaded[i]==true then newTooltip[i+3] = "- Snitch (R)";	end end
			if ObeyPanel1Loaded[i]==true then ObeyPanel1Loaded[i] = false;		RemoveObeyButtons();		if ObeyPanel2Loaded[i]==true then	newTooltip[i+3] = "- Obey (R)";		end end
			if GangPanel1Loaded[i]==true then GangPanel1Loaded[i] = false;		if i==0 then RemoveGang0Buttons() elseif i==1 then RemoveGang1Buttons() elseif i==2 then RemoveGang2Buttons() end	if GangPanel2Loaded[i]==true then newTooltip[i+3] = "- Gang (R)";	end end
			if EvacPanel1Loaded[i]==true then EvacPanel1Loaded[i] = false;		RemoveEvacButtons(); 		if EvacPanel2Loaded[i]==true then	newTooltip[i+3] = "- Evac (R)";		end end
			OtherPanel1Loaded[i] = false
			--Game.DebugOut("Did nothing A i="..i.." Resetting utilitypanel")
		end

		if currentSlotI[i+3] > 0 then -- find pager panel if something is loaded here, pager panel slots start at 3
			if PagerPanelLoaded[i]==false and OtherPanel2Loaded[i]==false then -- if no currently intalled panels are known for this display then check for a pagerpanel
				--Game.DebugOut("Checking for pager panels i="..i.."")
				MyPanels = this.GetNearbyObjects('Pager',2)
				PagerPanelLoaded[i] = false
				for thatPanel, distance in pairs (MyPanels) do
					if (thatPanel.CarrierId.i==this.Id.i and thatPanel.CarrierId.u==this.Id.u) and (thatPanel.Id.i==currentSlotI[i+3] and thatPanel.Id.u==currentSlotU[i+3]) then
						Object.SetProperty(thatPanel,"HomeUID",this.HomeUID)
						MyPagerPanel[i]=thatPanel -- import my new pagerpanel
						PagerPanelLoaded[i] = true
						--Game.DebugOut("Pager panel i="..i.." loaded")
						if MyPagerPanel[i].PanelType=="Power (R)" then
							PowerPanel2Loaded[i]=true
							--Game.DebugOut("Power (R) i="..i.." loaded")
						elseif MyPagerPanel[i].PanelType=="Snitch Sorter (R)" then
							SnitchPanel2Loaded[i]=true
							--Game.DebugOut("snitch (R) i="..i.." loaded")
						elseif MyPagerPanel[i].PanelType=="Obey (R)" then
							ObeyPanel2Loaded[i]=true
							--Game.DebugOut("Obey (R) i="..i.." loaded")
						elseif MyPagerPanel[i].PanelType=="MinSec" then
							GangPanel2Loaded[i]=true
							--Game.DebugOut("MinSec i="..i.." loaded")
						elseif MyPagerPanel[i].PanelType=="Normal" then
							GangPanel2Loaded[i]=true
							--Game.DebugOut("Normal i="..i.." loaded")
						elseif MyPagerPanel[i].PanelType=="MaxSec" then
							GangPanel2Loaded[i]=true
							--Game.DebugOut("MaxSec i="..i.." loaded")
						elseif MyPagerPanel[i].PanelType=="SuperMax" then
							GangPanel2Loaded[i]=true
							--Game.DebugOut("SuperMax i="..i.." loaded")
						elseif MyPagerPanel[i].PanelType=="Protected" then
							GangPanel2Loaded[i]=true
							--Game.DebugOut("Protected i="..i.." loaded")
						elseif MyPagerPanel[i].PanelType=="DeathRow" then
							GangPanel2Loaded[i]=true
							--Game.DebugOut("DeathRow i="..i.." loaded")
						elseif MyPagerPanel[i].PanelType=="Evac (R)" then
							EvacPanel2Loaded[i]=true
							--Game.DebugOut("Evac (R) i="..i.." loaded")
						end
					end
				end
				MyPanels=nil
				if PagerPanelLoaded[i]==false and OtherPanel2Loaded[i]==false then -- the loaded panel is not a PagerPanel, so it must be an eyecandy panel
					--Game.DebugOut("Checking for displaypanels(R) i="..i.."")
					MyPanels = this.GetNearbyObjects('DisplayPanelRight',2)
					for thatPanel, distance in pairs (MyPanels) do
						if (thatPanel.CarrierId.i==this.Id.i and thatPanel.CarrierId.u==this.Id.u) and (thatPanel.Id.i==currentSlotI[i+3] and thatPanel.Id.u==currentSlotU[i+3]) then
							Object.SetProperty(thatPanel,"HomeUID",this.HomeUID)
							newTooltip[i+3] = "- Display (R)"
							OtherPanel2Loaded[i]=true
							--Game.DebugOut("Displaypanel (R) i="..i.." loaded")
						end
					end
					MyPanels=nil
				else
					if PowerPanel2Loaded[i]==true then
						newTooltip[i+3] = "- Power (R)"
					elseif SnitchPanel2Loaded[i]==true then
						newTooltip[i+3] = "- Snitch (R)"
					elseif ObeyPanel2Loaded[i]==true then
						newTooltip[i+3] = "- Obey (R)"
					elseif GangPanel2Loaded[i]==true then
						newTooltip[i+3] = "- Gang (R)"
					elseif EvacPanel2Loaded[i]==true then
						newTooltip[i+3] = "- Evac (R)"
					else
						newTooltip[i+3] = "x"..MyPagerPanel[i].xTimes..""
					end
				end
				if PagerPanelLoaded[i]==false and OtherPanel2Loaded[i]==false then -- the loaded thing is probably a box with a panel inside... :s Getting rid of it.
					--Game.DebugOut("Checking for a box... i="..i.."")
					MyPanels = this.GetNearbyObjects('Box',2)
					for thatPanel, distance in pairs (MyPanels) do
						if (thatPanel.CarrierId.i==this.Id.i and thatPanel.CarrierId.u==this.Id.u) and (thatPanel.Id.i==currentSlotI[i+3] and thatPanel.Id.u==currentSlotU[i+3]) then
							thatPanel.Delete()
							currentSlotI[i+3]=nil
							currentSlotU[i+3]=nil
							newTooltip[i+3] = "(empty)"
						end
					end
					MyPanels=nil
				end
			else -- else we already know what's inside, so we don't need to do any other checks
				--Game.DebugOut("Did nothing D i="..i.."")
			end
		else -- reset the panel booleans to false since there is A) no panel installed yet, or B) a panel has been removed, so we need to search for a new panel on next update()
			newTooltip[i+3] = "(empty)"
			newSwitchTooltip[i] = ""
			newSwitchTooltip[i+3] = ""
			newSwitchTooltip[8] = ""
			PagerPanelLoaded[i] = false
			if PowerPanel2Loaded[i]==true then PowerPanel2Loaded[i] = false;	RemovePowerButtons();	if PowerPanel1Loaded[i]==true then	newTooltip[i] = "\nDisplay "..DisplayNumber..": Power (L)";	end end
			if SnitchPanel2Loaded[i]==true then SnitchPanel2Loaded[i] = false;	RemoveSnitchButtons();	if SnitchPanel1Loaded[i]==true then	newTooltip[i] = "\nDisplay "..DisplayNumber..": Snitch (L)";	end end
			if ObeyPanel2Loaded[i]==true then ObeyPanel2Loaded[i] = false;		RemoveObeyButtons();	if ObeyPanel1Loaded[i]==true then	newTooltip[i] = "\nDisplay "..DisplayNumber..": Obey (L)";		end end
			if GangPanel2Loaded[i]==true then GangPanel2Loaded[i] = false;		if i==0 then RemoveGang0Buttons() elseif i==1 then RemoveGang1Buttons() elseif i==2 then RemoveGang2Buttons(); end	if GangPanel1Loaded[i]==true then newTooltip[i] = "\nDisplay "..DisplayNumber..": Gang (L)";	end end
			if EvacPanel2Loaded[i]==true then EvacPanel2Loaded[i] = false;		RemoveEvacButtons();	if EvacPanel1Loaded[i]==true then	newTooltip[i] = "\nDisplay "..DisplayNumber..": Evac";			end end
			OtherPanel2Loaded[i] = false
			--Game.DebugOut("Did nothing C i="..i.." Resetting buttons and tooltips")
		end
	end
	--Game.DebugOut("==FindMyPanels finished==")
end

function SetMyTooltips()
	Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	if MySwitch.HomeUID==nil then -- no switch? then no booth eiter.
		DeleteBooth()
	else
		Object.SetProperty(MySwitch,"Tooltip","Used by Utility Booth nr. "..MySwitch.HomeUID.."\n"..newSwitchTooltip[0].." "..newSwitchTooltip[3]..""..newSwitchTooltip[1].." "..newSwitchTooltip[4]..""..newSwitchTooltip[2].." "..newSwitchTooltip[5]..""..newSwitchTooltip[6]..""..newSwitchTooltip[7]..""..newSwitchTooltip[8].."\n\nTip: wire a Power Switch to a Logic Bridge.\nWire the Logic Bridge to several booth switches.\nHit the main Power Switch to turn on the booths.")
	end	
end

function UpdatePanelValues()
	--Game.DebugOut("==UpdatePanelValues STARTING==")
	MySlotSize = this.SlotSize
	for i=0,MySlotSize do
		if OtherPanel1Loaded[i]~=true then -- if no eyecandy panel is installed, then we need to do some more stuff, else we just sit here and do nothing
			if UtilityPanelLoaded[i]==true then -- if utility is loaded and a pager panel as well, then takeover the settings in order to update the status of the powerswitch
				if PowerPanel1Loaded[i]==true then -- but first let's check if a Power controller has been installed
					if PowerPanel2Loaded[i]==true then
						--Game.DebugOut("Updating POWER CONTROL i="..i.."")
						newSwitchTooltip[i]="\n\nPOWER CONTROL installed.\nUse me to control powered objects within a given range."
						newSwitchTooltip[i+3] = ""
						newSwitchTooltip[8] = "\n\nClick the Utility Booth for more options."
						if ReadyToPower==false then
							AddPowerButtons()
							Object.Sound("UtilityBooth","ResetBooth")
							ReadyToPower=true
						end
						newTooltip[i] = "\nDisplay "..(i+1)..": POWER CONTROL\n          Range: "..this.PowerRange.."m\n"
						newTooltip[i+3] = ""
					else
						ReadyToPower=false
						Object.SetProperty(MyUtilityPanel[i],"SubType",7) -- show the 'Need panel' display until a pager panel is found
					end
				elseif SnitchPanel1Loaded[i]==true then -- let's check if a snitch sorter has been installed
					if SnitchPanel2Loaded[i]==true then
						--Game.DebugOut("Updating SNITCH SORTER i="..i.."")
						newSwitchTooltip[i]="\n\nSNITCH sorter installed.\nTurn me on to start sorting snitches."
						newSwitchTooltip[i+3] = ""
						newSwitchTooltip[8] = "\n\nClick the Utility Booth for more options."
						if ReadyToSnitch==false then
							if this.RNDSnitchTimer==nil then
								RandomSnitchTimer=math.random(9,24)/math.pi
								timeToDoSnitchSort=RandomSnitchTimer
								Object.SetProperty(this,"RNDSnitchTimer",RandomSnitchTimer)
							end
							AddSnitchButtons()
							Object.Sound("UtilityBooth","ResetBooth")
							ReadyToSnitch=true
						end
						newTooltip[i] = "\nDisplay "..(i+1)..": SNITCH SORTER\n          Range: "..this.SnitchRange.."m\n          Interval: "..string.sub(tostring(this.RNDSnitchTimer),0,4).."\n"
						newTooltip[i+3] = ""
					else
						ReadyToSnitch=false
						Object.SetProperty(MyUtilityPanel[i],"SubType",7) -- show the 'Need panel' display until a pager panel is found
					end
				elseif ObeyPanel1Loaded[i]==true then -- let's check if a Obey has been installed
					if ObeyPanel2Loaded[i]==true then
						--Game.DebugOut("Updating OBEY MACHINE i="..i.."")
						newSwitchTooltip[i]="\n\nOBEY panels installed.\nTurn me on to start suppressing prisoners."
						newSwitchTooltip[i+3] = ""
						newSwitchTooltip[8] = "\n\nClick the Utility Booth for more options."
						if ReadyToObey==false then
							if this.RNDObeyTimer==nil then
								RandomObeyTimer=(math.random(15,30)+math.random(2,30))/math.pi
								timeToDoObey=RandomObeyTimer
								Object.SetProperty(this,"RNDObeyTimer",RandomObeyTimer)
							end
							AddObeyButtons()
							Object.Sound("UtilityBooth","ResetBooth")
							ReadyToObey=true
						end
						newTooltip[i] = "\nDisplay "..(i+1)..": OBEY MACHINE\n          Range: "..this.ObeyRange.."m\n          Interval: "..string.sub(tostring(this.RNDObeyTimer),0,4).."\n"
						newTooltip[i+3] = ""
					else
						ReadyToObey=false
						Object.SetProperty(MyUtilityPanel[i],"SubType",7) -- show the 'Need panel' display until a pager panel is found
					end
				elseif GangPanel1Loaded[i]==true then -- let's check if a Gang Sorter has been installed
					if GangPanel2Loaded[i]==true then
						--Game.DebugOut("Updating GANG SORTER i="..i.."")
						if i==0 then -- for now there is no shorter way but to go through gang sorter 0, 1 and 2 via if i=0 i=1 and i=2 routines... 
							if this.GangSorter0==nil then
								Object.SetProperty(this,"GangSorter0","GangToSection")
							else
								SortGangs0=this.GangSorter0
							end
							if this.GangSorter0=="GangToSection" then
								newSwitchTooltip[i]="\n\nGANG sorter installed.\nTurn me on to send\n"..MyUtilityPanel[i].PanelType.." members to "..MyPagerPanel[i].PanelType.." area.\n"
								dir0txt = MyUtilityPanel[i].PanelType.." -> "..MyPagerPanel[i].PanelType
							else
								newSwitchTooltip[i]="\n\nGANG sorter installed.\nTurn me on to change\n"..MyPagerPanel[i].PanelType.." prisoners into "..MyUtilityPanel[i].PanelType.." members.\n"
								dir0txt = MyPagerPanel[i].PanelType.." -> "..MyUtilityPanel[i].PanelType
							end
							if ReadyToGangSort0==false then
								Object.SetProperty(this,"GangId0",MyUtilityPanel[i].GangId)
								Object.SetProperty(this,"GangCat0",MyPagerPanel[i].PanelType)
								Object.SetProperty(this,"Category0",MyPagerPanel[i].Category)
								if this.RNDGang0Timer==nil then
									RandomGang0Timer=math.random(2,16)/math.pi
									timeToDoGang0=RandomGang0Timer
									Object.SetProperty(this,"RNDGang0Timer",RandomGang0Timer)
								end
								AddGang0Buttons()
								Object.Sound("UtilityBooth","ResetBooth")
								ReadyToGangSort0=true
							end
							newTooltip[i] = "\nDisplay "..(i+1)..": "..dir0txt.."\n          Range: "..this.GangRange0.."m\n          Interval: "..string.sub(tostring(this.RNDGang0Timer),0,4).."\n"
						elseif i==1 then -- for now there is no shorter way but to go through gang sorter 0, 1 and 2 via if i=0 i=1 and i=2 routines... 
							if this.GangSorter1==nil then
								Object.SetProperty(this,"GangSorter1","GangToSection")
							else
								SortGangs1=this.GangSorter1
							end
							if this.GangSorter1=="GangToSection" then
								newSwitchTooltip[i]="\n\nGANG sorter installed.\nTurn me on to send\n"..MyUtilityPanel[i].PanelType.." members to "..MyPagerPanel[i].PanelType.." area.\n"
								dir1txt = MyUtilityPanel[i].PanelType.." -> "..MyPagerPanel[i].PanelType
							else
								newSwitchTooltip[i]="\n\nGANG sorter installed.\nTurn me on to change\n"..MyPagerPanel[i].PanelType.." prisoners into "..MyUtilityPanel[i].PanelType.." members.\n"
								dir1txt = MyPagerPanel[i].PanelType.." -> "..MyUtilityPanel[i].PanelType
							end
							if ReadyToGangSort1==false then
								Object.SetProperty(this,"GangId1",MyUtilityPanel[i].GangId)
								Object.SetProperty(this,"GangCat1",MyPagerPanel[i].PanelType)
								Object.SetProperty(this,"Category1",MyPagerPanel[i].Category)
								if this.RNDGang1Timer==nil then
									RandomGang1Timer=math.random(2,16)/math.pi
									timeToDoGang1=RandomGang1Timer
									Object.SetProperty(this,"RNDGang1Timer",RandomGang1Timer)
								end
								AddGang1Buttons()
								Object.Sound("UtilityBooth","ResetBooth")
								ReadyToGangSort1=true
							end
							newTooltip[i] = "\nDisplay "..(i+1)..": "..dir1txt.."\n          Range: "..this.GangRange1.."m\n          Interval: "..string.sub(tostring(this.RNDGang1Timer),0,4).."\n"
						elseif i==2 then -- for now there is no shorter way but to go through gang sorter 0, 1 and 2 via if i=0 i=1 and i=2 routines... 
							if this.GangSorter2==nil then
								Object.SetProperty(this,"GangSorter2","GangToSection")
							else
								SortGangs2=this.GangSorter2
							end
							if this.GangSorter2=="GangToSection" then
								newSwitchTooltip[i]="\n\nGANG sorter installed.\nTurn me on to send\n"..MyUtilityPanel[i].PanelType.." members to "..MyPagerPanel[i].PanelType.." area.\n"
								dir2txt = MyUtilityPanel[i].PanelType.." -> "..MyPagerPanel[i].PanelType
							else
								newSwitchTooltip[i]="\n\nGANG sorter installed.\nTurn me on to change\n"..MyPagerPanel[i].PanelType.." prisoners into "..MyUtilityPanel[i].PanelType.." members.\n"
								dir2txt = MyPagerPanel[i].PanelType.." -> "..MyUtilityPanel[i].PanelType
							end
							if ReadyToGangSort2==false then
								Object.SetProperty(this,"GangId2",MyUtilityPanel[i].GangId)
								Object.SetProperty(this,"GangCat2",MyPagerPanel[i].PanelType)
								Object.SetProperty(this,"Category2",MyPagerPanel[i].Category)
								if this.RNDGang2Timer==nil then
									RandomGang2Timer=math.random(2,16)/math.pi
									timeToDoGang2=RandomGang2Timer
									Object.SetProperty(this,"RNDGang2Timer",RandomGang2Timer)
								end
								AddGang2Buttons()
								Object.Sound("UtilityBooth","ResetBooth")
								ReadyToGangSort2=true
							end
							newTooltip[i] = "\nDisplay "..(i+1)..": "..dir2txt.."\n          Range: "..this.GangRange2.."m\n          Interval: "..string.sub(tostring(this.RNDGang2Timer),0,4).."\n"
						end
						newSwitchTooltip[i+3] = ""
						newSwitchTooltip[8] = "\n\nClick the Utility Booth for more options."
						newTooltip[i+3] = ""
					else
						if i==0 then ReadyToGangSort0=false
						elseif i==1 then ReadyToGangSort1=false
						elseif i==2 then ReadyToGangSort2=false end
						Object.SetProperty(MyUtilityPanel[i],"SubType",7) -- show the 'Need panel' display until a pager panel is found
					end
				elseif EvacPanel1Loaded[i]==true then -- let's check if an Evac has been installed
					if EvacPanel2Loaded[i]==true then
						--Game.DebugOut("Updating EVACUATION i="..i.."")
						if MyPagerPanel[i].EvacGroup=="Prisoners" or MyPagerPanel[i].EvacGroup=="ALL" then
							newSwitchTooltip[i]="\n\nEVACUATION panels installed.\nWire me to Evacuation Alarm(s) Selective.\nTurn me on to evacuate "..MyPagerPanel[i].EvacGroup.." to this booth.\n\nWARNING\nPrisoners only evacuate during FreeTime or Work!"
						else
							newSwitchTooltip[i]="\n\nEVACUATION panels installed.\nWire me to Evacuation Alarm(s) Selective.\nTurn me on to evacuate "..MyPagerPanel[i].EvacGroup.." to this booth."
						end
						newSwitchTooltip[i+3] = ""
						newSwitchTooltip[8] = "\n\nClick the Booth and the Alarm(s) for more options."
						if ReadyToEvac==false then
							if this.RNDEvacTimer==nil then
								RandomEvacTimer=math.random(5,12)/math.pi
								timeToDoEvac=RandomEvacTimer
								Object.SetProperty(this,"RNDEvacTimer",RandomEvacTimer)
							end
							AddEvacButtons()
							Object.Sound("UtilityBooth","ResetBooth")
							ReadyToEvac=true
						end
						Object.SetProperty(MyUtilityPanel[i],"EvacType",MyPagerPanel[i].EvacType)
						Object.SetProperty(this,"EvacType",MyPagerPanel[i].EvacType)
						newTooltip[i] = "\nDisplay "..(i+1)..": EVAC "..MyPagerPanel[i].EvacGroup.."\n          Range: "..this.EvacRange.."m\n          Interval: "..string.sub(tostring(this.RNDEvacTimer),0,4).."\n"
						newTooltip[i+3] = ""
					else
						ReadyToEvac=false
						Object.SetProperty(MyUtilityPanel[i],"SubType",7) -- show the 'Need panel' display until a pager panel is found
					end
				else
					if PowerPanel2Loaded[i]==false and EvacPanel2Loaded[i]==false and ObeyPanel2Loaded[i]==false and SnitchPanel2Loaded[i]==false and GangPanel2Loaded[i]==false and PagerPanelLoaded[i]==true then -- it wasn't an Evac nor Obey nor snitch sorter, so let's get the pager values	
						--Game.DebugOut("Updating STAFF PAGER i="..i.."")
						if MyUtilityPanel[i].PanelType=="Workman" then
							Object.Sound("UtilityBooth","ResetBooth")
							newSwitchTooltip[i]="\n\nSTAFF PAGERS installed.\nTurn me on to call "..MyPagerPanel[i].xTimes.." workmen.\nTurn me off to dismiss them."
						else
							Object.Sound("UtilityBooth","ResetBooth")
							newSwitchTooltip[i]="\n\nSTAFF PAGERS installed.\nTurn me on to call "..MyPagerPanel[i].xTimes.." "..MyUtilityPanel[i].PanelType.."s.\nTurn me off to dismiss them."
						end
						newSwitchTooltip[i+3] = ""
						Object.SetProperty(MyUtilityPanel[i],"xTimes",MyPagerPanel[i].xTimes) -- takeover xtimes value from the pagerpanel. since pagers can be replaced we need to update this to be sure the correct amount of staff gets spawned
					else -- pager not present or has been removed, so reset utilitypanel
						newSwitchTooltip[i]=""
						newSwitchTooltip[i+3] = ""
						newSwitchTooltip[8] = ""
						--Game.DebugOut("Resetting utilitypanel i="..i.."")
						Object.SetProperty(MyUtilityPanel[i],"xTimes",0)
						Object.SetProperty(MyUtilityPanel[i],"SwitchIsOn",false)
						Object.SetProperty(MyUtilityPanel[i],"SubType",5) -- show the 'No Pager' display until a pager panel is found
					end
				end
			else -- else do nothing at all, we don't care if there is a pagerpanel loaded without a utilitypanel
				--Game.DebugOut("Did nothing F i="..i.."")
			end
		else -- else there was just eyecandy loaded so we do nothing
			--Game.DebugOut("Did nothing E i="..i.."")
		end
	end
	--Game.DebugOut("==UpdatePanelValues FINISHED==")
end

function TurnPowerOff(myItem)
	--Game.DebugOut("==POWER OFF==")
	PoweredObjects=0
	nearbyPoweredObjects = GetObjectsInSquare(myItem,this.PowerRange) -- get all objects in range which are not powered off yet
	for thatObject, distance in pairs (nearbyPoweredObjects) do -- turn those off
		if thatObject.EmergencyLight==nil and thatObject.origPosX==nil then
			local ObjectOff = Object.Spawn(myItem.."Off",thatObject.Pos.x,thatObject.Pos.y)
			Object.SetProperty(ObjectOff,"Tooltip","\nThis "..myItem.." can be turned ON by\na Utility Booth with Power Panels.")
			Object.SetProperty(ObjectOff,"Or.x",thatObject.Or.x)
			Object.SetProperty(ObjectOff,"Or.y",thatObject.Or.y)
			if myItem=="CctvMonitor" or myItem=="DoorControlSystem" or myItem=="PhoneMonitor" then -- move wired items beneath the utility booth and hide them
				Object.SetProperty(thatObject,"origPosX",thatObject.Pos.x)
				Object.SetProperty(thatObject,"origPosY",thatObject.Pos.y)
				Object.SetProperty(thatObject,"Pos.x",powerOffPosX)
				Object.SetProperty(thatObject,"Pos.y",powerOffPosY)
				Object.SetProperty(thatObject,"Powered",false)
				Object.SetProperty(thatObject,"On",false)
				Object.SetProperty(thatObject,"Hidden",true)
			else
				thatObject.Delete() -- delete original powered object, except the wired ones to be able to keep the connections.
			end
			PoweredObjects=PoweredObjects+1
		end
	end
	nearbyPoweredObjects=nil
end

function TurnPowerOn(myItem)
	--Game.DebugOut("==POWER ON==")
	PoweredObjects=0
	if myItem=="CctvMonitor" or myItem=="DoorControlSystem" or myItem=="PhoneMonitor" then -- move wired objects back to original x/y and unhide
		myWiredObjects = Object.GetNearbyObjects(this,myItem,3)
		for thatObject, distance in pairs (myWiredObjects) do
			if thatObject.origPosX~=nil then
				Object.SetProperty(thatObject,"Hidden",false)
				Object.SetProperty(thatObject,"Pos.x",thatObject.origPosX)
				Object.SetProperty(thatObject,"Pos.y",thatObject.origPosY)
				Object.SetProperty(thatObject,"Powered",true)
				Object.SetProperty(thatObject,"On",true)
				Object.SetProperty(thatObject,"origPosX","")
				Object.SetProperty(thatObject,"origPosY","")
				PoweredObjects=PoweredObjects+1
			end
		end
	end
	nearbyOffObjects = GetObjectsInSquare(myItem.."Off",this.PowerRange) -- get all other objects in range which are not powered on yet
	for thatObject, distance in pairs (nearbyOffObjects) do -- turn those on
		if thatObject.EmergencyLight==nil then
			if myItem~="CctvMonitor" and myItem~="DoorControlSystem" and myItem~="PhoneMonitor" then
				local ObjectOn = Object.Spawn(myItem,thatObject.Pos.x,thatObject.Pos.y)
				Object.SetProperty(ObjectOn,"Or.x",thatObject.Or.x)
				Object.SetProperty(ObjectOn,"Or.y",thatObject.Or.y)
				PoweredObjects=PoweredObjects+1			
			end
			thatObject.Delete()
		end
	end
	myWiredObjects=nil
	nearbyOffObjects=nil
end

function DoSnitchSorting()
	--Game.DebugOut("==SNITCHSORTER ACTIVE==")
	local NumMinSec=0
	local NumNormal=0
	local NumMaxSec=0
	local NumSuperMax=0
	local NumProtected=0
	local NumDeathRow=0
	local snitchprisoners = GetObjectsInSquare("Prisoner", this.SnitchRange)
	if next(snitchprisoners) then
		for name,dist in pairs( snitchprisoners ) do
			if name.SnitchTimer~=0 then
				--Game.DebugOut("Prisoner is snitch")
				if name.Category=="MinSec" and SortMin=="YES" then
					Object.SetProperty(name,"Category",4)
					Object.Sound("UtilityBooth","SnitchFound")
					NumMinSec=NumMinSec+1
				elseif name.Category=="Normal" and SortMed=="YES" then
					Object.SetProperty(name,"Category",4)
					Object.Sound("UtilityBooth","SnitchFound")
					NumNormal=NumNormal+1
				elseif name.Category=="MaxSec" and SortMax=="YES" then
					Object.SetProperty(name,"Category",4)
					Object.Sound("UtilityBooth","SnitchFound")
					NumMaxSec=NumMaxSec+1
				elseif name.Category=="SuperMax" and SortSuper=="YES" then
					Object.SetProperty(name,"Category",4)
					Object.Sound("UtilityBooth","SnitchFound")
					NumSuperMax=NumSuperMax+1
				elseif name.Category=="DeathRow" and SortDeath=="YES" then
					Object.SetProperty(name,"Category",4)
					Object.Sound("UtilityBooth","SnitchFound")
					NumDeathRow=NumDeathRow+1
				end
			end
		end
		newTooltip[6] = "\nSNITCH SORTING RESULTS:\n   "..NumMinSec.." MinSec, "..NumNormal.." MedSec\n   "..NumMaxSec.." MaxSec, "..NumSuperMax.." SuperMax\n   "..NumProtected.." Protected, "..NumDeathRow.." Death Row\n"
	else
		newTooltip[6] = "\nSNITCH SORTING RESULTS:\n   No prisoners found"
	end
	snitchprisoners=nil
	Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	TooltipFilled=true
end

function DoObeyMachine()
	--Game.DebugOut("==OBEY ACTIVE==")
	local NumMinSec=0
	local NumNormal=0
	local NumMaxSec=0
	local NumSuperMax=0
	local NumProtected=0
	local NumDeathRow=0
	local obeyprisoners = GetObjectsInSquare("Prisoner", this.ObeyRange)
	if next(obeyprisoners) then
		for name,dist in pairs( obeyprisoners ) do
			if name.Category=="MinSec" and ObeyMin=="YES" then
				name.StatusEffects.suppressed = 1500
				Object.Sound("UtilityBooth","WhisperObey")
				NumMinSec=NumMinSec+1
			elseif name.Category=="Normal" and ObeyMed=="YES" then
				name.StatusEffects.suppressed = 1500
				Object.Sound("UtilityBooth","WhisperObey")
				NumNormal=NumNormal+1
			elseif name.Category=="MaxSec" and ObeyMax=="YES" then
				name.StatusEffects.suppressed = 1500
				Object.Sound("UtilityBooth","WhisperObey")
				NumMaxSec=NumMaxSec+1
			elseif name.Category=="SuperMax" and ObeySuper=="YES" then
				name.StatusEffects.suppressed = 1500
				Object.Sound("UtilityBooth","WhisperObey")
				NumSuperMax=NumSuperMax+1
			elseif name.Category=="Protected" and ObeyProt=="YES" then
				name.StatusEffects.suppressed = 1500
				Object.Sound("UtilityBooth","WhisperObey")
				NumProtected=NumProtected+1
			elseif name.Category=="DeathRow" and ObeyDeath=="YES" then
				name.StatusEffects.suppressed = 1500
				Object.Sound("UtilityBooth","WhisperObey")
				NumDeathRow=NumDeathRow+1
			end
		end
		newTooltip[7] = "\nOBEY CHIP ACTIVATED IN:\n   "..NumMinSec.." MinSec, "..NumNormal.." MedSec\n   "..NumMaxSec.." MaxSec, "..NumSuperMax.." SuperMax\n   "..NumProtected.." Protected, "..NumDeathRow.." Death Row\n"
	else
		newTooltip[7] = "\nOBEY MACHINE RESULTS:\n   No prisoners found"
	end
	obeyprisoners=nil
	Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	TooltipFilled=true
end

function AnimateEvac()
	MySlotSize = this.SlotSize
	for i=0,MySlotSize do
		if EvacPanel1Loaded[i]==true and EvacPanel2Loaded[i]==true then
			Frame = Frame + 1
			if Frame > #Animation then
				Frame = 1
			end
			Object.SetProperty(MyUtilityPanel[i],"SubType",Animation[Frame]) -- animate the Evac display
		end
	end
end

function DoEvacuation()
	--Game.DebugOut("==EVACUATION ACTIVE==")
	if MySwitch.EvacTestRun=="NO" then
		local NumPrisoners=0
		local NumPeople=0
		Object.Sound("UtilityBooth","Evacuate")
		AnimateEvac()
		local group = GROUPS[this.EvacType]
		for _, typ in pairs(group) do
			local evacpeople = GetObjectsInSquare(typ, this.EvacRange)
			if next(evacpeople) then
				for entity, _ in pairs(evacpeople) do
					if entity.Type=="Prisoner" then
						Object.ClearRouting(entity) --clearrouting doesn't seem to kill jobs, so have to do that manually
						entity.JobId=0 -- kill prisoners job
						entity.Station.i=0 -- clear the links to whatever he was working on
						entity.Station.u=0
						entity.StatusEffects.suppressed = 0 -- remove suppression so he can run fast
						entity.Needs.Evacuation = 100 -- give him some reasons to run
						entity.Needs.Safety = 100
						NumPrisoners=NumPrisoners+1
					else
						Object.ClearRouting(entity)
						Object.NavigateTo(entity, this.Pos.x, this.Pos.y+2)
						NumPeople=NumPeople+1
					end
				end
			end
			evacpeople=nil
		end
		newTooltip[8] = "\nEVACUATED:\n   "..NumPrisoners.." Prisoners, "..NumPeople.." Staff/Visitors\n"
	else
		Object.Sound("UtilityBooth","Evacuate")
		AnimateEvac()
		newTooltip[8] = "\nEVACUATION TEST RUN\nThis is only a test mode to ensure proper wiring.\nNo people have been evacuated during this test.\nSet Alarm Test to NO on the booth to actually evacuate.\n"
	end
	Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	TooltipFilled=true
end

function DoGangSorting0()
	--Game.DebugOut("==GANGSORTER ACTIVE==")
	local NumGangToSection=0
	local NumSectionToGang=0
	if SortGangs0=="GangToSection" then
		local prisoners0a = GetObjectsInSquare("Prisoner", this.GangRange0)
		if next(prisoners0a) then
			for name,dist in pairs( prisoners0a ) do
				if name.Gang.Id==this.GangId0 and name.Category~=this.GangCat0 then
					name.Category = this.Category0
					Object.Sound("UtilityBooth","GangSort")
					NumGangToSection=NumGangToSection+1
				end
			end
			newTooltip[9] = "\nGANG SORTING RESULTS:\n   "..NumGangToSection.." gang members sorted to "..this.GangCat0.." area\n"
		else
			newTooltip[9] = "\nGANG SORTING RESULTS:\n   No prisoners found"
		end
		prisoners0a=nil
		Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	end
	if SortGangs0=="SectionToGang" then
		if SalvagedPrisoners0==0 then
			Interface.AddComponent(this,"toggleUndoSectionToGang0", "Button", "tooltip_button_undo",SalvagedPrisoners0,"X")
		end
		local prisoners0b = GetObjectsInSquare("Prisoner", this.GangRange0)
		if next(prisoners0b) then
			for name,dist in pairs( prisoners0b ) do
				if name.Gang.Id==0 then
					if name.Category==this.GangCat0 and name.Gang.Id~=this.GangId0 then
						Object.Sound("UtilityBooth","GangSort")
						mySectionToGangList0[mySectionToGangListNumber0]=name.Id.u
						mySectionToGangListNumber0=mySectionToGangListNumber0+1
						SalvagedPrisoners0=mySectionToGangListNumber0
						name.Gang.Id=this.GangId0
						local RandomRank=math.random(0,102)
						if RandomRank<=90 then
							name.Gang.Rank=1
						elseif RandomRank>90 and RandomRank<=100 then
							name.Gang.Rank=2
						else
							name.Gang.Rank=3
						end
						name.Gang.Recruitment=1.000000
						NumSectionToGang=NumSectionToGang+1
					end
				end
			end
			this.SetInterfaceCaption("toggleUndoSectionToGang0", "tooltip_button_undo",SalvagedPrisoners0,"X")
			newTooltip[9] = "\nGANG SORTING RESULTS:\n   "..NumSectionToGang.." prisoners changed into gang member\n"
		else
			newTooltip[9] = "\nGANG SORTING RESULTS:\n   No prisoners found"
		end
		prisoners0b=nil
		Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	end
	TooltipFilled=true
end

function DoGangSorting1()
	--Game.DebugOut("==GANGSORTER ACTIVE==")
	local NumGangToSection=0
	local NumSectionToGang=0
	if SortGangs1=="GangToSection" then
		local prisoners1a = GetObjectsInSquare("Prisoner", this.GangRange1)
		if next(prisoners1a) then
			for name,dist in pairs( prisoners1a ) do
				if name.Gang.Id==this.GangId1 and name.Category~=this.GangCat1 then
					name.Category = this.Category1
					Object.Sound("UtilityBooth","GangSort")
					NumGangToSection=NumGangToSection+1
				end
			end
			newTooltip[10] = "\n\nGANG SORTING RESULTS:\n   "..NumGangToSection.." gang members sorted to "..this.GangCat1.." area"
		else
			newTooltip[10] = "\nGANG SORTING RESULTS:\n   No prisoners found"
		end
		prisoners1a=nil
		Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	end
	if SortGangs1=="SectionToGang" then
		if SalvagedPrisoners1==0 then
			Interface.AddComponent(this,"toggleUndoSectionToGang1", "Button", "tooltip_button_undo",SalvagedPrisoners1,"X")
		end
		local prisoners1b = GetObjectsInSquare("Prisoner", this.GangRange1)
		if next(prisoners1b) then
			for name,dist in pairs( prisoners1b ) do
				if name.Gang.Id==0 then
					if name.Category==this.GangCat1 and name.Gang.Id~=this.GangId1 then
						Object.Sound("UtilityBooth","GangSort")
						mySectionToGangList1[mySectionToGangListNumber1]=name.Id.u
						mySectionToGangListNumber1=mySectionToGangListNumber1+1
						SalvagedPrisoners1=mySectionToGangListNumber1
						name.Gang.Id=this.GangId1
						local RandomRank=math.random(0,102)
						if RandomRank<=90 then
							name.Gang.Rank=1
						elseif RandomRank>90 and RandomRank<=100 then
							name.Gang.Rank=2
						else
							name.Gang.Rank=3
						end
						name.Gang.Recruitment=1.000000
					end
				end
			end
			this.SetInterfaceCaption("toggleUndoSectionToGang1", "tooltip_button_undo",SalvagedPrisoners1,"X")
			newTooltip[10] = "\nGANG SORTING RESULTS:\n   "..NumSectionToGang.." prisoners changed into gang member\n"
		else
			newTooltip[10] = "\nGANG SORTING RESULTS:\n   No prisoners found"		
		end
		prisoners1b=nil
		Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	end
	TooltipFilled=true
end

function DoGangSorting2()
	--Game.DebugOut("==GANGSORTER ACTIVE==")
	local NumGangToSection=0
	local NumSectionToGang=0
	if SortGangs2=="GangToSection" then
		local prisoners2a = GetObjectsInSquare("Prisoner", this.GangRange2)
		if next(prisoners2a) then
			for name,dist in pairs( prisoners2a ) do
				if name.Gang.Id==this.GangId2 and name.Category~=this.GangCat2 then
					name.Category = this.Category2
					Object.Sound("UtilityBooth","GangSort")
					NumGangToSection=NumGangToSection+1
				end
			end
			newTooltip[11] = "\nGANG SORTING RESULTS:\n   "..NumGangToSection.." gang members sorted to "..this.GangCat2.." area\n"
		else
			newTooltip[11] = "\nGANG SORTING RESULTS:\n   No prisoners found"
		end
		prisoners2a=nil
		Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	end
	if SortGangs2=="SectionToGang" then
		if SalvagedPrisoners2==0 then
			Interface.AddComponent(this,"toggleUndoSectionToGang2", "Button", "tooltip_button_undo",SalvagedPrisoners2,"X")
		end
		local prisoners2b = GetObjectsInSquare("Prisoner", this.GangRange2)
		if next(prisoners2b) then
			for name,dist in pairs( prisoners2b ) do
				if name.Gang.Id==0 then
					if name.Category==this.GangCat2 and name.Gang.Id~=this.GangId2 then
						Object.Sound("UtilityBooth","GangSort")
						mySectionToGangList2[mySectionToGangListNumber2]=name.Id.u
						mySectionToGangListNumber2=mySectionToGangListNumber2+1
						SalvagedPrisoners2=mySectionToGangListNumber2
						name.Gang.Id=this.GangId2
						local RandomRank=math.random(0,102)
						if RandomRank<=90 then
							name.Gang.Rank=1
						elseif RandomRank>90 and RandomRank<=100 then
							name.Gang.Rank=2
						else
							name.Gang.Rank=3
						end
						name.Gang.Recruitment=1.000000
					end
				end
			end
			this.SetInterfaceCaption("toggleUndoSectionToGang2", "tooltip_button_undo",SalvagedPrisoners2,"X")
			newTooltip[11] = "\nGANG SORTING RESULTS:\n   "..NumSectionToGang.." prisoners changed into gang member\n"
		else
			newTooltip[11] = "\nGANG SORTING RESULTS:\n   No prisoners found"
		end
		prisoners2b=nil
		Object.SetProperty(this,"Tooltip","S/N: "..this.HomeUID.."\n\nBelow is my panel list.\nPress Reset if it's wrong:\n"..newTooltip[0].." "..newTooltip[3]..""..newTooltip[1].." "..newTooltip[4]..""..newTooltip[2].." "..newTooltip[5]..""..newTooltip[6]..""..newTooltip[7]..""..newTooltip[8]..""..newTooltip[9]..""..newTooltip[10]..""..newTooltip[11]..""..newTooltip[12].."")
	end
	TooltipFilled=true
end

function DeleteBooth()

	if MySwitch~=nil then MySwitch.Delete() end
	
	if CoveredByPower==true then	HideCoveredArea("Power")	end
	if CoveredBySnitch==true then	HideCoveredArea("Snitch")	end
	if CoveredByObey==true then		HideCoveredArea("Obey")		end
	if CoveredByEvac==true then		HideCoveredArea("Evac")		end
	if CoveredByGang0==true then	HideCoveredArea("Gang"..tostring(this.GangId0-2).."A")	end
	if CoveredByGang1==true then	HideCoveredArea("Gang"..tostring(this.GangId1-2).."B")	end
	if CoveredByGang2==true then	HideCoveredArea("Gang"..tostring(this.GangId2-2).."C")	end

	if ReadyToPower==true then
		if PowerIsOn==false or PowerIsOn==nil then
			if PowerLights=="YES" then TurnPowerOn("Light");					PwrLight="\n          "..tostring(PoweredObjects).." Lights" end
			if PowerSaw=="YES" then TurnPowerOn("WorkshopSaw");					PwrSaw="\n          "..tostring(PoweredObjects).." Workshop Saws" end				
			if PowerPress=="YES" then TurnPowerOn("WorkshopPress");				PwrPress="\n          "..tostring(PoweredObjects).." Workshop Presses" end				
			if PowerFridge=="YES" then TurnPowerOn("Fridge");					PwrFridge="\n          "..tostring(PoweredObjects).." Fridges" end				
			if PowerCooker=="YES" then TurnPowerOn("Cooker");					PwrCooker="\n          "..tostring(PoweredObjects).." Cookers" end			
			if PowerMetal=="YES" then TurnPowerOn("MetalDetector");				PwrMetal="\n          "..tostring(PoweredObjects).." Metal Detectors" end	
			if PowerCCTV=="YES" then TurnPowerOn("CctvMonitor");				PwrCctv="\n          "..tostring(PoweredObjects).." CCTV Monitors" end				
			if PowerPhoneMonitor=="YES" then TurnPowerOn("PhoneMonitor");		PwrPhone="\n          "..tostring(PoweredObjects).." Phone Taps" end
			if PowerDoorControl=="YES" then TurnPowerOn("DoorControlSystem");	PwrDCS="\n          "..tostring(PoweredObjects).." Door Systems" end
		end
	end
	
	local controlPanels = this.GetNearbyObjects('ControlPanel',4)
	for thatPanel, distance in pairs (controlPanels) do
		if thatPanel.HomeUID==this.HomeUID then
			thatPanel.Delete()
		end
	end
	
	local displayPanels = this.GetNearbyObjects('DisplayPanelLeft',4)
	for thatPanel, distance in pairs (displayPanels) do
		if thatPanel.HomeUID==this.HomeUID then
			thatPanel.Delete()
		end
	end
	
	local displayPanels = this.GetNearbyObjects('DisplayPanelRight',4)
	for thatPanel, distance in pairs (displayPanels) do
		if thatPanel.HomeUID==this.HomeUID then
			thatPanel.Delete()
		end
	end
	
	local utilityPanels = this.GetNearbyObjects('UtilityPanel',4)
	for thatPanel, distance in pairs (utilityPanels) do
		if thatPanel.HomeUID==this.HomeUID then
			thatPanel.Delete()
		end
	end
	
	local pagerPanels = this.GetNearbyObjects('Pager',4)
	for thatPanel, distance in pairs (pagerPanels) do
		if thatPanel.HomeUID==this.HomeUID then
			thatPanel.Delete()
		end
	end
	
	local dummyPanels = this.GetNearbyObjects('DummyPanel',1000)
	for thatPanel, distance in pairs (dummyPanels) do
		if thatPanel.HomeUID==this.HomeUID then
			thatPanel.Delete()
			break
		end
	end
	
	this.Delete()
	
end

